unit Unit1;

interface

implementation

end.

unit ClassFactory;
interface
                                                                                                         
uses DBISAMTb, DB, DBISAMCt, Forms, Windows, Grids, StdCtrls, CheckLst,
SysUtils, Dialogs, IniFiles, ComCtrls, CommCtrl, Controls, DBClient, MidasLib;
const
  CFGName = 'cfg.ini';
  ECaminhoInvalido = 'Erro ao tentar abrir o arquivo: %s'+#13#10+'Caminho Invlido';
  ETitle = 'Erro';
  ETitleOK = 'Informao';
  ETitleErroLogin = 'Erro de Conexo';
  EErroInterno = 'Erro interno de funo'+#13#10+'Favor contactar o suporte para uma verso'+#13#10+
  'mais nova para o Priority';
  ENaoExistePesquisaCadastrada = 'No existe ainda o Projeto cadastrado com o n "%s"'+#13#10+
  'Esse procedimento  necessrio antes deste cadastro. Favor inserir primeiro dados da Pesquisa,'+#13#10+
  'para depois efetuar este cadastro.';
  EErroBancoDeDados = 'Erro ao carregar o Banco de Dados...'+#13+
  'Favor verificar as configuraes no arquivo %s';
  ErroAoFecharBanco = 'Erro ao Fechar o Banco de Dados.';

  EInformeDadosParaPesquisa = 'Informe os Dados de %s para Pesquisa.';
  EInformeDadosParaDelecao = 'Informe os Dados de %s para serem Deletados.';
  EInformePeso = 'Informe o Peso da Dimenso que ser incluido.';
  EInformeVariavel = 'Informe a Descrio da Varivel de Esforo'#13#10 +
  'que  ou ser usada no Cadastro (Default) das Perspectivas de Esforo';
  ProDLLName = 'Acesso.dll';
  ProCFGName = 'cfg.ini';
  ProDataBaseName = 'Priority';
  ProNormal             =  0;
  ProNaoEncontrouCodigo =  100;
  ProNaoEncontrouSigla =   102;
  ProNaoEncontrouVariavel = 103;
  ProNaoEncontrouNumero =  104;
  ProErroConsistencia   = -1;
  ProErroAoExecutarConsulta  = -9;
  ProErroAoCarregarHandleDLL = -6;
  ProStatusAtivo            = 'A';
  ProStatusInativo          = 'I';
  ProStatusNaoPersistente   = 'N';
type
  vAbreModelo = procedure;
  vFechaModelo = procedure;
  vExecuta = procedure (parm: Array of String; Query: String);
  vvExiste = function (Query: String): Boolean;
  vvCarregaStr = function (var strRes : TStringGrid; Query: string): Boolean;
  vCarregaCombo = function (var strRes : TCombobox; Query: string): Boolean;
  vvCarrega = procedure (var cmps: Array of String; Query: String);
var
  PathDLL, PathCfgIni: string;
  AbreModelo: vAbreModelo;
  FechaModelo: vFechaModelo;
  Executa: vExecuta;
  veExiste: vvExiste;
  CarregaStr: vvCarregaStr;
  CarregaCombo: vCarregaCombo;
  Carrega: vvCarrega;
  Campos: array of string;
  Ini : TIniFile;
  LibInstance: HMODULE;

type TConexao = class
private
  function CarregaBanco: boolean;
  function AbreBanco: boolean;
  function FechaBanco: boolean;
public
 class procedure SqlCommand(const Query: string);
 constructor create;
 destructor destroy; override;
end;

type TProjeto = class
  private
  FGera_Codigo: string;
  FData: string;
  FNome: string;
  FObjetivo: string;
  FAreaExecutora: string;
  FResponsavel: string;
  FMatricula: string;
  FQtdeAreasEnvolvidas: integer;
  FQtdeTotalDemandas: integer;
  FQtdeTotalVariaveis: integer;
  Frc: integer;
  FMensagem: string;
  FStatus: string;
  //variveis de Esforo/Custo. apenas para leitura ...
  FECC: string;
  FECF: string;
  Alterou: boolean;
  conexao: TConexao;
  procedure Executa(parm: Array of String; Query: String);
  procedure setGera_Codigo(const Value: string);
  procedure setData(const Value: string);
  procedure setNome(const Value: string);
  procedure setObjetivo(const Value: string);
  procedure setAreaExecutora(const Value: string);
  procedure setResponsavel(const Value: string);
  procedure setMatricula(const Value: string);
  procedure setQtdeAreasEnvolvidas(const Value: integer);
  procedure setQtdeTotalDemandas(const Value: integer);
  procedure SetQtdeTotalVariaveis(const Value: integer);
  procedure SetStatus(const Value: string);
  public
  property Gera_Codigo: string     read FGera_Codigo write setGera_Codigo;
  property Data: string            read FData write setData;
  property Nome: string            read FNome write setNome;
  property Objetivo: string        read FObjetivo write setObjetivo;
  property AreaExecutora: string   read FAreaExecutora write setAreaExecutora;
  property Responsavel: string     read FResponsavel write setResponsavel;
  property Matricula: string       read FMatricula write setMatricula;
  property QtdeAreasEnvolvidas: integer read FQtdeAreasEnvolvidas write setQtdeAreasEnvolvidas;
  property QtdeTotalDemandas: integer   read FQtdeTotalDemandas write setQtdeTotalDemandas;
  property QtdeTotalVariaveis: integer  read FQtdeTotalVariaveis write SetQtdeTotalVariaveis;
  property Status: string               read FStatus write SetStatus;
  property ECC: string read FECC;
  property ECF: string read FECF;
  // Propriedades apenas para leitura
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;

  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  constructor   Create(const parmCodigo: string;
  const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;
  function Persistir: boolean;
  procedure AtualizaCascataProjeto(const OldPGeraCodigo: string; NewPGeraCodigo: string);
  function SalvaOpcoesEsforcoCusto(const PGeraCodigo: string; const POpcao: integer): boolean;
  class function ProcuraCodigo(const PCodigo: string;
  const parmDataBaseName: string = ProDataBaseName): boolean;
  class function RetornaCodigo(const PCodigo: string;
  const parmDataBaseName: string = ProDataBaseName): string;
  function RetornaECC_EFC(const PGeraCodigo: string): string;
  function RetornaQtdeAreasDemandasVariaveis(const PCodigo: string;
  const parmDataBaseName: string = ProDataBaseName): string;
  function  BuscarInstanciaNoBanco(const PCodigo: string): boolean;
  function  NaoPersistir(const parmCodigo: string): boolean;
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function CarregaDadosComboBox(var strRes : TCombobox; Query: string): Boolean;
end;

type TArea = class
  private
  FSigla: string;
  FNome: string;
  FRepresentante: string;
  FMatricula: string;
  Frc: integer;
  FMensagem: string;
  FStatus: string;
  fGera_Codigo: string;
  Alterou: boolean;
  FTotalRegistros: integer;
  FQtdeRegistrosDoProjeto: integer;
  conexao: TConexao;
  procedure Executa(parm: Array of String; Query: String);
  procedure setSigla(const Value: string);
  procedure setNome(const Value: string);
  procedure setRepresentante(const Value: string);
  procedure setMatricula(const Value: string);
  procedure SetStatus(const Value: string);

  public
  property Sigla: string     read FSigla write setSigla;
  property Nome: string            read FNome write setNome;
  property Representante: string        read FRepresentante write setRepresentante;
  property Matricula: string   read FMatricula write setMatricula;
  property Status: string               read FStatus write SetStatus;
  property Gera_Codigo: string read fGera_Codigo;
  property TotalRegistros: integer  read FTotalRegistros;
  property QtdeRegistrosDoProjeto: integer read FQtdeRegistrosDoProjeto;
  // Propriedades apenas para leitura
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;

  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;
  function Persistir(const Value: string; const TotalRegistros: integer): boolean;
  class function ProcuraSigla(const PSigla: string;
  const parmDataBaseName: string = ProDataBaseName): boolean;
  class function RetornaSigla(const PSigla: string; const PGera_Codigo: string): string;
  procedure AtualizaCascataSigla(const PGeraCodigo: string; const OldPSigla: string; NewPSigla: string);
  function  BuscarInstanciaNoBanco(const PSigla: string; const PGera_Codigo: string): boolean;
  function  BuscarInstanciaNoBancoStringGrid(const PSigla: string; const PGera_Codigo: string): boolean;
  function  NaoPersistir(const parmSigla: string; const parmGera_Codigo: string): boolean;
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function CarregaDadosComboBox(var strRes : TCombobox; Query: string): Boolean;
  function CarregaDadosEmUmaVariavel(var Str: string; Query: string): Boolean;
  function RetornaDadosEmUmaVariavel(var Str: string; Query: string): string;
end;
type TAreaProjeto = class
  private
  FSigla: string;
  FNome: string;
  Frc: integer;
  FMensagem: string;
  FStatus: string;
  Alterou: boolean;
  conexao: TConexao;
  procedure Executa(parm: Array of String; Query: String);
  procedure setSigla(const Value: string);
  procedure setNome(const Value: string);
  public
  property Sigla: string     read FSigla write setSigla;
  property Nome: string            read FNome write setNome;
  // Propriedades apenas para leitura
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;

  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;
  function Persistir(const PSigla, PNome: string): boolean;
  function  BuscarInstanciaNoBanco(const PSigla, PNome: string): boolean;
  function  LocalizaArea(const PNome: string): boolean;
  function  NaoPersistir(const PSigla, PNome: string): boolean;
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function CarregaDadosComboBox(var strRes : TCombobox; Query: string): Boolean;
end;

type TDemanda = class
  private
  FGera_Codigo: string;
  FSigla: string;
  FNumero: string;
  FDescricao: string;
  Frc: integer;
  FMensagem: string;
  FTotalRegistros: integer;
  Alterou: boolean;
  conexao: TConexao;
  procedure Executa(parm: Array of String; Query: String);
  procedure setDescricao(const Value: string);
  procedure SetNumero(const Value: string);
    class function ProcuraArea(const PArea,
      parmDataBaseName: string): boolean;
    class function ProcuraNumero(const PNumero: string;
      const parmDataBaseName: string): boolean;
  public
  procedure setSigla(const Value: string);
  property Sigla: string     read FSigla write setSigla;
  property Descricao: string     read FDescricao write setDescricao;
  property Gera_Codigo: string read fGera_Codigo;
  // Propriedades apenas para leitura
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;
  property Numero: string     read FNumero write SetNumero;
  property TotalRegistros: integer  read FTotalRegistros;
  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;
  function Persistir(const PNumero: string; const PGera_Codigo: string; const TotalRegistros: integer): boolean;
  class function RetornaNumero(const PNumero: string;
      const PGera_Codigo: string): boolean;
  class function NumeroExiste(const PNumero: string; const PGera_Codigo: string): boolean;
  function  BuscarInstanciaNoBanco(const PNumero: string; const PGera_Codigo: string): boolean;
  function  NaoPersistir(const Value: string; const ParmGera_Codigo: string): boolean;
  function RetornaDadosEmUmaVariavel(var Str: string; Query: string): string;
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function CarregaDadosComboBox(var strRes : TCombobox; Query: string): Boolean;
end;

type TDimensao = class
  private
  FDimensao: string;
  Frc:       integer;
  FMensagem: string;
  Alterou:   boolean;
  conexao: TConexao;
  procedure setDimensao(const Value: string);
  public
  property Dimensao: string     read FDimensao write setDimensao;
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;
   constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
   destructor    Destroy; override;
   function CarregaDadosListBox(var strRes : TListBox; Query: string): Boolean;
   function CarregaDadosComboBox(var strRes : TCombobox; Query: string): Boolean;
end;

  type TDimensaoPeso = class(TDimensao)
    private
    FProjeto: string;
    FPeso: string;
    FCodigoDimensao: string;
    procedure SetPeso(const Value: string);
    procedure Executa(parm: Array of String; Query: String);
    public
    property Projeto: string read FProjeto;
    property CodigoDimensao: string read FCodigoDimensao;
    property Peso: string read FPeso write SetPeso;
    class function ProjetoExiste(const PGera_Codigo: String): boolean;
    class function ProjetoExisteComMesmaDimensao(const PGera_Codigo: string; const PDescricaoDimensao: string): boolean;
    function Persistir(const PGera_Codigo: string; const PDescricao_Dimensao: string; const Peso: string): boolean;
    function NaoPersistir(const PGera_Codigo: string; const PDescricao_Dimensao: string): Boolean;
    function Selecionar(const PGera_Codigo: string): boolean;
    function CarregaDadosDimensaoPeso(var strRes : TListBox; Query: string): Boolean;
    function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  {  constructor   Create
   (const parmDataBaseName: string = ProDataBaseName); overload;
    destructor    Destroy; override;
   }
  end;
 
type TVariavel = class
  private
  FCodigo: string;
  FDescricaoDimensao: string;
  FDescricaoVariavel: string;
  FRepresentante: string;
  Frc: integer;
  FMensagem: string;
  Alterou: boolean;
  conexao: TConexao;
  procedure Executa(parm: Array of String; Query: String);
  procedure setDescricaoVariavel(const Value: string);
  public
  property Codigo: string read FCodigo;
  property DescricaoDimensao: string     read FDescricaoDimensao;
  property DescricaoVariavel: string     read FDescricaoVariavel write setDescricaoVariavel;
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;
  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;
  function Persistir(const PDescricaDimensao: string; const PDescricaoVariavel: string): boolean;
  class function ExisteDimensao(const PDescricaDimensao: string): boolean;
  class function ExisteVariavel(const PDescricaoVariavel: string): boolean;
  class function ExisteDimensaoComVariavel(const PDescricaDimensao: string;
  const PDescricaoVariavel: string): boolean;
  function  BuscarInstanciaNoBanco(const PDescricaoDimensao: string; const PDescricaoVariavel: string): string;
  function  BuscarInstanciasDaVariavel(const PDescricaoVariavel: string): boolean;
  function  NaoPersistir(const PDescricaoVariavel: string): boolean;
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function CarregaDadosComboBox(var strRes : TCombobox; Query: string): Boolean;
end;
 
type TVariavelEsforcoCustoConceitual = class
  private
  conexao: TConexao;
  FPeso: string;
  FSelecionado: string;
  FDescricaoECC: string;
  Frc: integer;
  FMensagem: string;
  procedure SetPeso(const Value: string);
  procedure SetSelecionado(const Value: string);
  procedure SetDescricaoECC(const Value: string);
  procedure Executa(parm: Array of String; Query: String);
  public
  property Peso: string read FPeso write SetPeso;
  property Selecionado: string read FSelecionado write SetSelecionado;
  property DescricaoECC: string read FDescricaoECC write SetDescricaoECC;
  // Propriedades apenas para leitura
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;

  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function BuscaInstanciaVariavelEsforco(const PDescricaoECC: string; const PGeraCodigo: string): Boolean;
  procedure RetornaInstanciaBanco(const PDescricaoECC: string; const PGeraCodigo: string);
  function InserirVariavelEsforco(const PDescricaoECC: string; const PGeraCodigo: string): Boolean;
  function RetornaDadosEmUmaVariavel(var Str: string; Query: string): string;
  procedure MarcaApenasUmaVariavelDeCadaVez(const PDescricaoECC: string; const PGeraCodigo: string);
  function Persistir(const PDescricaoECC: string; const PGeraCodigo: string; const Peso: string): Boolean;
  function NaoPersistir(const PDescricaoECC: string; const PGeraCodigo: string): Boolean;
  procedure PersistirVariavelDefault(const PDescricaoECC: string);
  procedure NaoPersistirVariavelDefault(const PDescricaoECC: string);
end;
 
type TVariavelEsforcoCustoFinanceiro = class
  private
  FPeso: string;
  FSelecionado: string;
  FDescricaoECF: string;
  Frc: integer;
  FMensagem: string;
  conexao: TConexao;
  procedure Executa(parm: Array of String; Query: String);
  procedure SetPeso(const Value: string);
  procedure SetSelecionado(const Value: string);
  procedure SetDescricaoECF(const Value: string);
  public
  property Peso: string read FPeso write SetPeso;
  property Selecionado: string read FSelecionado write SetSelecionado;
  property DescricaoECF: string read FDescricaoECF write SetDescricaoECF;
  // Propriedades apenas para leitura
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;

  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function BuscaInstanciaVariavelEsforco(const PDescricaoECF: string; const PGeraCodigo: string): Boolean;
  function InserirVariavelEsforco(const PDescricaoECF: string; const PGeraCodigo: string): Boolean;
  function RetornaDadosEmUmaVariavel(var Str: string; Query: string): string;
  procedure RetornaInstanciaBanco(const PDescricaoECF: string; const PGeraCodigo: string);
  procedure MarcaApenasUmaVariavelDeCadaVez(const PDescricaoECF: string; const PGeraCodigo: string);
  function Persistir(const PDescricaoECF: string; const PGeraCodigo: string; const Peso: string): Boolean;
  function NaoPersistir(const PDescricaoECF: string; const PGeraCodigo: string): Boolean;
  procedure PersistirVariavelDefault(const PDescricaoECF: string);
  procedure NaoPersistirVariavelDefault(const PDescricaoECF: string);

end;
type TVariavelEsforcoComplexidade = class
  private
  FPeso: string;
  FSelecionado: string;
  FDescricaoECA: string;
  Frc: integer;
  FMensagem: string;
  conexao: TConexao;
  procedure Executa(parm: Array of String; Query: String);
  procedure SetPeso(const Value: string);
  procedure SetSelecionado(const Value: string);
  procedure SetDescricaoECA(const Value: string);
  public
  property Peso: string read FPeso write SetPeso;
  property Selecionado: string read FSelecionado write SetSelecionado;
  property DescricaoECA: string read FDescricaoECA write SetDescricaoECA;
  // Propriedades apenas para leitura
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;
  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function BuscaInstanciaVariavelEsforco(const PDescricaoECA: string; const PGeraCodigo: string): Boolean;
  function InserirVariavelEsforco(const PDescricaoECA: string; const PGeraCodigo: string): Boolean;
  function RetornaDadosEmUmaVariavel(var Str: string; Query: string): string;
  procedure RetornaInstanciaBanco(const PDescricaoECA: string; const PGeraCodigo: string);
  procedure MarcaApenasUmaVariavelDeCadaVez(const PDescricaoECA: string; const PGeraCodigo: string);
  function Persistir(const PDescricaoECA: string; const PGeraCodigo: string; const Peso: string): Boolean;
  function NaoPersistir(const PDescricaoECA: string; const PGeraCodigo: string): Boolean;
  procedure PersistirVariavelDefault(const PDescricaoECA: string);
  procedure NaoPersistirVariavelDefault(const PDescricaoECA: string);
end;

type TVariavelEsforcoTempo = class
  private
  FPeso: string;
  FSelecionado: string;
  FDescricaoECT: string;
  Frc: integer;
  FMensagem: string;
  conexao: TConexao;
  procedure Executa(parm: Array of String; Query: String);
  procedure SetPeso(const Value: string);
  procedure SetSelecionado(const Value: string);
  procedure SetDescricaoECT(const Value: string);
  public
  property Peso: string read FPeso write SetPeso;
  property Selecionado: string read FSelecionado write SetSelecionado;
  property DescricaoECT: string read FDescricaoECT write SetDescricaoECT;
  // Propriedades apenas para leitura
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;
  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function BuscaInstanciaVariavelEsforco(const PDescricaoECT: string; const PGeraCodigo: string): Boolean;
  function InserirVariavelEsforco(const PDescricaoECT: string; const PGeraCodigo: string): Boolean;
  function RetornaDadosEmUmaVariavel(var Str: string; Query: string): string;
  procedure RetornaInstanciaBanco(const PDescricaoECT: string; const PGeraCodigo: string);
  procedure MarcaApenasUmaVariavelDeCadaVez(const PDescricaoECT: string; const PGeraCodigo: string);
  function Persistir(const PDescricaoECT: string; const PGeraCodigo: string; const Peso: string): Boolean;
  function NaoPersistir(const PDescricaoECT: string; const PGeraCodigo: string): Boolean;
  procedure PersistirVariavelDefault(const PDescricaoECT: string);
  procedure NaoPersistirVariavelDefault(const PDescricaoECT: string);

end;
 
type TVariaveis_Projeto = class
  private
  FGera_Codigo: string;
  FDescricaoDimensao: string;
  FDescricaoVariavel: string;
  FMarcado: boolean;
  Frc: integer;
  FMensagem: string;
  Alterou: boolean;
  FTotalRegistros: integer;
  conexao: TConexao;
  procedure Executa(parm: Array of String; Query: String);
  procedure setDescricaoVariavel(const Value: string);
  procedure SetMarcado(const Marcado: boolean);
  public
  property Gera_Codigo: string read FGera_Codigo;
  property DescricaoDimensao: string     read FDescricaoDimensao;
  property DescricaoVariavel: string     read FDescricaoVariavel write setDescricaoVariavel;
  property Marcado: boolean              read FMarcado           write SetMarcado;
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;
  property TotalRegistros: integer read FTotalRegistros;
  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;
  function Persistir(const PGeraCodigo: string; const PDescricaoDimensao: string; const PDescricaoVariavel: string; const TotalRegistros: integer): boolean;
  function Marcar(const PGeraCodigo: string; const PDescricaoVariavel: string): boolean;
  function Desmarcar(const PGeraCodigo: string; const PDescricaoVariavel: string): boolean;
  class function ExisteVariavel(const PGeraCodigo: string; const PDescricaoVariavel: string): boolean;
  class function RetornaDimensaoDaVariavelExistente(const PGeraCodigo: string; const PDescricaoVariavel: string): string;
  function RetornaDadosEmUmaVariavel(var Str: string; Query: string): string;
  function LocalizaVariavel(const PGeraCodigo: string; const PDescricaoVariavel: string): boolean;
  function  BuscarInstanciaNoBanco(const PGeraCodigo: string; const PDescricaoVariavel: string): string;
  function  BuscarInstanciasDaVariavel(const PGeraCodigo: string; const PDescricaoVariavel: string): string;
  function  NaoPersistir(const PGeraCodigo: string; const PDescricaoVariavel: string): boolean;
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function CarregaDadosComboBox(var strRes : TCombobox; Query: string): Boolean;
  function CarregaDadosCheckListBox(var strRes : TCheckListBox; Query: string): Boolean;
  function CarregaVariaveisSelecionadas(var strRes : TCheckListBox; Query: string): Boolean;
  function CarregaVariaveisNaoSelecionadas(var strRes : TCheckListBox; Query: string): Boolean;
  function CarregaVariaveisNaoSelecionadasSemEsvaziar(var strRes : TCheckListBox; Query: string): Boolean;
  function CarregaDimensoes_e_VariaveisSelecionadas(
  const PGeraCodigo: string;
  var strRes: TtreeView): Boolean;
end;

type TNotas = class
  private
  FGera_Codigo: string;
  FDescricaoDemanda: string;
  FDescricaoDimensao: string;
  FDescricaoVariavel: string;
  FNotas: integer;
  Frc: integer;
  FMensagem: string;
  Alterou: boolean;
  conexao: TConexao;
  procedure Executa(parm: Array of String; Query: String);
  procedure setNota(const Value: integer);
  public
  property Gera_Codigo: string read FGera_Codigo;
  property DescricaoDemanda: string      read FDescricaoDemanda;
  property DescricaoDimensao: string     read FDescricaoDimensao;
  property DescricaoVariavel: string     read FDescricaoVariavel;
  property Notas: integer     read FNotas write setNota;
  property rc: integer         read Frc;
  property Mensagem: string    read FMensagem;
  function Persistir(const PGeraCodigo: string;
  const PDescricaoDemandas: string;
  const PDescricaoDimensao: string;
  const PDescricaoVariavel: string;
  const PNota: integer): boolean;
  procedure RemoveNotas(const PGeraCodigo: string);
  function CarregaDadosStringGrid(var strRes : TStringGrid; Query: string): Boolean;
  function CarregaNotasParaTodasAsDemandas(var PClientdataset: TClientDataSet; PGeraCodigo: string): Boolean;
  constructor   Create
  (const parmDataBaseName: string = ProDataBaseName); overload;
  destructor    Destroy; override;

end;

// ***************************************************
implementation
uses dModelo, Classes, Biblioteca;
{ TProjeto }
function TProjeto.BuscarInstanciaNoBanco(const PCodigo: string): boolean;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  Result := False;
  with D_Modelo.QrConsulta do
    begin
      Close;
      ParamByName('CODIGO').AsString := PCodigo;
      Open;
      Result := (D_Modelo.QrConsulta.RecordCount <> 0);
      if Result then
      begin
      FData   := D_Modelo.QrConsulta.fieldByName('DATA').AsString;
      FGera_Codigo := D_Modelo.QrConsulta.fieldByName('GERA_CODIGO').AsString;
      FObjetivo := D_Modelo.QrConsulta.fieldByName('OBJETIVO').AsString;
      FAreaExecutora := D_Modelo.QrConsulta.fieldByName('AREA_EXECUTORA').AsString;
      FResponsavel := D_Modelo.QrConsulta.fieldByName('RESPONSAVEL').AsString;
      FMatricula := D_Modelo.QrConsulta.fieldByName('MATRICULA').AsString;
      FQtdeAreasEnvolvidas := D_Modelo.QrConsulta.fieldByName('QTDE_AREAS_ENVOLVIDAS').AsInteger;
      FQtdeTotalDemandas :=   D_Modelo.QrConsulta.fieldByName('QTDE_TOTAL_DEMANDAS').AsInteger;
      FQtdeTotalVariaveis :=  D_Modelo.QrConsulta.fieldByName('QTDE_TOTAL_VARIAVEIS').AsInteger;
      FNome := D_Modelo.QrConsulta.fieldByName('NOME').AsString;
      end;
      end;
      Alterou := False;

end;
constructor TProjeto.Create(const parmDataBaseName: string = ProDataBaseName);
begin
   conexao := TConexao.create;
{  if not CarregaBanco then
  Application.MessageBox(Pchar(Format(EErroBancoDeDados,[CFGName])),
  ETitleOK,MB_OK+MB_ICONWARNING);  }
end;

constructor TProjeto.Create(const parmCodigo: string; const parmDataBaseName: string = ProDataBaseName);
begin
  Self.Create(parmCodigo, parmDataBaseName);
  FGera_Codigo := parmCodigo;
  FGera_Codigo := '0';
  Frc := ProNaoEncontrouCodigo;
  FMensagem := 'Projeto no encontrado com o Cdigo ' + parmCodigo;

end;
destructor TProjeto.Destroy;
begin
  if Alterou then
    Persistir;
    conexao.Free;
    inherited Destroy;
end;
function TProjeto.NaoPersistir(const parmCodigo: string): boolean;
var
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  with D_Modelo.QrConsulta do
    begin
      Close;
      ParamByName('CODIGO').AsString := parmCodigo;
      Open;
    end;
   Result := (D_Modelo.QrConsulta.RecordCount <> 0);
   if Result then
   begin
     SetLength(Parametros, 1);
     Query := 'DELETE FROM PROJETO WHERE GERA_CODIGO =:VAL01';
     Parametros[0] := parmCodigo;
     Executa(Parametros, Query);
     conexao.SqlCommand('DELETE FROM AREA WHERE GERA_CODIGO = ' + QuotedStr(parmCodigo));
     conexao.SqlCommand('DELETE FROM DEMANDAS WHERE GERA_CODIGO = ' + QuotedStr(parmCodigo));
     conexao.SqlCommand('DELETE FROM DIMENSAO_PESO WHERE CODIGO_PROJETO = ' + QuotedStr(parmCodigo));
     conexao.SqlCommand('DELETE FROM VARIAVEIS_PROJETO WHERE GERA_CODIGO = ' + QuotedStr(parmCodigo));
     conexao.SqlCommand('DELETE FROM ECA_PROJETO WHERE GERA_CODIGO = ' + QuotedStr(parmCodigo));
     conexao.SqlCommand('DELETE FROM ECC_PROJETO WHERE GERA_CODIGO = ' + QuotedStr(parmCodigo));
     conexao.SqlCommand('DELETE FROM ECF_PROJETO WHERE GERA_CODIGO = ' + QuotedStr(parmCodigo));
     conexao.SqlCommand('DELETE FROM ECT_PROJETO WHERE GERA_CODIGO = ' + QuotedStr(parmCodigo));
   end
   else
   begin
     Frc := ProNaoEncontrouCodigo;
     FMensagem := 'O Cdigo informado no existe';
   end;
end;
function TProjeto.Persistir: boolean;
var
  Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  FCodigoPesquisa: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  setData(Data);
  if not rc = proNormal then exit;
  setGera_Codigo(Gera_Codigo);
  if not rc = proNormal then exit;
  setNome(Nome);
  if not rc = proNormal then exit;
  setObjetivo(Objetivo);
  if not rc = proNormal then exit;
  setAreaExecutora(AreaExecutora);
  if not rc = proNormal then exit;
  setResponsavel(Responsavel);
  if not rc = proNormal then exit;
  setMatricula(Matricula);
  if not rc = proNormal then exit;
  setQtdeAreasEnvolvidas(QtdeAreasEnvolvidas);
  if not rc = proNormal then exit;
  setQtdeTotalDemandas(QtdeTotalDemandas);
  if not rc = proNormal then exit;
  SetQtdeTotalVariaveis(QtdeTotalVariaveis);
  if not rc = proNormal then exit;

   FCodigoPesquisa := RetornaCodigo(Gera_Codigo);
   if FCodigoPesquisa <> EmptyStr then
   begin
    SetLength(Parametros, 10);
    Query := 'UPDATE PROJETO SET DATA = :VALOR01, NOME = :VALOR02, ' +
    'OBJETIVO = :VALOR03, AREA_EXECUTORA = :VALOR04, RESPONSAVEL = :VALOR05, ' +
    'MATRICULA = :VALOR06, QTDE_AREAS_ENVOLVIDAS = :VALOR07, QTDE_TOTAL_DEMANDAS = :VALOR08, '+
    'QTDE_TOTAL_VARIAVEIS = :VALOR09 ' +
    'WHERE GERA_CODIGO = :VALOR10';
    Parametros[9] := FCodigoPesquisa;
    IndPar := 0;
    CarregaParam(Data);
    CarregaParam(Nome);
    CarregaParam(Objetivo);
    CarregaParam(AreaExecutora);
    CarregaParam(Responsavel);
    CarregaParam(Matricula);
    CarregaParam(IntToStr(QtdeAreasEnvolvidas));
    CarregaParam(IntToStr(QtdeTotalDemandas));
    CarregaParam(IntToStr(QtdeTotalVariaveis));
    Executa(Parametros, Query);
     Alterou := false;
     Result := true;
    end
    else
    begin
      SetLength(Parametros, 10);
      Query := 'INSERT INTO PROJETO (DATA, GERA_CODIGO, NOME, OBJETIVO, AREA_EXECUTORA, '+
      'RESPONSAVEL, MATRICULA, QTDE_AREAS_ENVOLVIDAS, QTDE_TOTAL_DEMANDAS, QTDE_TOTAL_VARIAVEIS)' +
      ' VALUES (:VAL01, :VAL02, :VAL03, :VAL04, :VAL05, :VAL06, :VAL07, :VAL08, :VAL09, :VAL10)' ;
      IndPar := 0;
      CarregaParam(Data);
      CarregaParam(Gera_Codigo);
      CarregaParam(Nome);
      CarregaParam(Objetivo);
      CarregaParam(AreaExecutora);
      CarregaParam(Responsavel);
      CarregaParam(Matricula);
      CarregaParam(IntToStr(QtdeAreasEnvolvidas));
      CarregaParam(IntToStr(QtdeTotalDemandas));
      CarregaParam(IntToStr(QtdeTotalVariaveis));
      Executa(Parametros, Query);
      Alterou := False;
      Result := True;
    end;
end;
class function TProjeto.ProcuraCodigo(const PCodigo: string;
const parmDataBaseName: string = ProDataBaseName): Boolean;
var
  Projeto: TProjeto;
begin
  Projeto := TProjeto.Create;
  try
  @veExiste := GetProcAddress(LibInstance, 'VeExiste');
    if @veExiste = nil then
      begin
        Application.MessageBox(PChar(EErroInterno) ,ETitle,MB_OK+MB_ICONERROR);
        FreeLibrary(LibInstance);
      end;
    if VeExiste ('PROJETO WHERE GERA_CODIGO = ' + QuotedStr(PCodigo)) then
    Result := True
    else
    Result := False;
    finally
    Projeto.Free;
    end;

end;
procedure TProjeto.setAreaExecutora(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo rea Executora';
  end
  else
  begin
    FAreaExecutora := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TProjeto.setData(const Value: string);
begin
  if Value = '  /  /    ' then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Data';
  end
  else
  begin
    FData := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TProjeto.setGera_Codigo(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Gera Cdigo';
  end
  else
  begin
    FGera_Codigo := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TProjeto.setMatricula(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Matrcula';
  end
  else
  begin
    FMatricula := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TProjeto.setNome(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Nome';
  end
  else
  begin
    FNome := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TProjeto.setObjetivo(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Objetivo';
  end
  else
  begin
    FObjetivo := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TProjeto.setQtdeAreasEnvolvidas(const Value: integer);
begin
  if IntToStr(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Qtde de reas Envolvidas';
  end
  else if (Value < 0) or (Value > 10) then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'O Intervalo da Quantidade de reas Envolvidas'+#13#10+
    ' entre 0 a 10';
  end
  else
  begin
    FQtdeAreasEnvolvidas := Value;
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TProjeto.setQtdeTotalDemandas(const Value: integer);
begin
  if IntToStr(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Qtde Total de Demandas';
  end
  else if (Value < 0) or (Value > 30) then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'O Intervalo da Quantidade de Total de Demandas'+#13#10+
    ' entre 0 a 30';
  end
  else
  begin
    FQtdeTotalDemandas := Value;
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TProjeto.setResponsavel(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Responsvel';
  end
  else
  begin
    FResponsavel := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;

class function TProjeto.RetornaCodigo(const PCodigo,
  parmDataBaseName: string): string;
begin
  with D_Modelo.QrConsulta do
    begin
      Close;
      ParamByName('CODIGO').AsString := PCodigo;
      Open;
      Result := D_Modelo.QrConsulta.fieldByName('GERA_CODIGO').AsString;
    end;
end;

procedure TProjeto.SetStatus(const Value: string);
begin
end;
procedure TProjeto.Executa(parm: array of String; Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;
function TProjeto.CarregaDadosStringGrid(var strRes: TStringGrid;
  Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);
end;
function TProjeto.CarregaDadosComboBox(var strRes: TCombobox;
  Query: string): Boolean;
var
  i: Integer;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
procedure TProjeto.SetQtdeTotalVariaveis(const Value: integer);
begin
  if IntToStr(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Qtde Total de Variveis';
  end
  else if (Value < 0) or (Value > 10) then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'O Intervalo da Quantidade de Variveis Envolvidas'+#13#10+
    ' entre 0 a 10';
    end
  else
  begin
    FQtdeTotalVariaveis := Value;
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
function TProjeto.RetornaQtdeAreasDemandasVariaveis(const PCodigo,
  parmDataBaseName: string): string;
begin
  Result := '';
  with D_Modelo.QrConsulta do
    begin
      Close;
      ParamByName('CODIGO').AsString := PCodigo;
      Open;
      if D_Modelo.QrConsulta.RecordCount <> 0 then
        begin
          FQtdeAreasEnvolvidas := D_Modelo.QrConsulta.fieldByName('QTDE_AREAS_ENVOLVIDAS').AsInteger;
          FQtdeTotalDemandas := D_Modelo.QrConsulta.fieldByName('QTDE_TOTAL_DEMANDAS').AsInteger;
          FQtdeTotalVariaveis := D_Modelo.QrConsulta.fieldByName('QTDE_TOTAL_VARIAVEIS').AsInteger;
          Result := D_Modelo.QrConsulta.fieldByName('GERA_CODIGO').AsString;
        end;
    end;
end;
procedure TProjeto.AtualizaCascataProjeto(const OldPGeraCodigo: string;
  NewPGeraCodigo: string);
begin
  conexao.SqlCommand('UPDATE PROJETO SET GERA_CODIGO = ' + QuotedStr(NewPGeraCodigo) +
         ' WHERE GERA_CODIGO = ' + QuotedStr(OldPGeraCodigo));
  conexao.SqlCommand('UPDATE AREA SET GERA_CODIGO = ' + QuotedStr(NewPGeraCodigo) +
         ' WHERE GERA_CODIGO = ' + QuotedStr(OldPGeraCodigo));
  conexao.SqlCommand('UPDATE DEMANDAS SET GERA_CODIGO = ' + QuotedStr(NewPGeraCodigo) +
         ' WHERE GERA_CODIGO = ' + QuotedStr(OldPGeraCodigo));
  conexao.SqlCommand('UPDATE DIMENSAO_PESO SET CODIGO_PROJETO = ' + QuotedStr(NewPGeraCodigo) +
         ' WHERE CODIGO_PROJETO = ' + QuotedStr(OldPGeraCodigo));
  conexao.SqlCommand('UPDATE VARIAVEIS_PROJETO SET GERA_CODIGO = ' + QuotedStr(NewPGeraCodigo) +
         ' WHERE GERA_CODIGO = ' + QuotedStr(OldPGeraCodigo));
  conexao.SqlCommand('UPDATE ECC_PROJETO SET GERA_CODIGO = ' + QuotedStr(NewPGeraCodigo) +
         ' WHERE GERA_CODIGO = ' + QuotedStr(OldPGeraCodigo));
  conexao.SqlCommand('UPDATE ECA_PROJETO SET GERA_CODIGO = ' + QuotedStr(NewPGeraCodigo) +
         ' WHERE GERA_CODIGO = ' + QuotedStr(OldPGeraCodigo));
  conexao.SqlCommand('UPDATE ECF_PROJETO SET GERA_CODIGO = ' + QuotedStr(NewPGeraCodigo) +
         ' WHERE GERA_CODIGO = ' + QuotedStr(OldPGeraCodigo));
  conexao.SqlCommand('UPDATE ECT_PROJETO SET GERA_CODIGO = ' + QuotedStr(NewPGeraCodigo) +
         ' WHERE GERA_CODIGO = ' + QuotedStr(OldPGeraCodigo));
end;
function TProjeto.SalvaOpcoesEsforcoCusto(const PGeraCodigo: string;
  const POpcao: integer): boolean;
var
  Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  FCodigoPesquisa: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
   FGera_Codigo := PGeraCodigo;
   FCodigoPesquisa := RetornaCodigo(Gera_Codigo);
   if FCodigoPesquisa <> EmptyStr then
   begin
    SetLength(Parametros, 2);
    if POpcao = 0 then
      begin
        Query := 'UPDATE PROJETO SET ECC = TRUE, ECF = FALSE'#13#10+
        'WHERE GERA_CODIGO = :VALOR1';
        Parametros[0] := FCodigoPesquisa;
        IndPar := 0;
        CarregaParam(Gera_Codigo);
        Executa(Parametros, Query);
         Alterou := false;
         Result := true;
       end
    else
    begin
      if POpcao = 1 then
      begin
        Query := 'UPDATE PROJETO SET ECF = TRUE, ECC = FALSE'#13#10+
        'WHERE GERA_CODIGO = :VALOR1';
        Parametros[0] := FCodigoPesquisa;
        IndPar := 0;
        CarregaParam(Gera_Codigo);
        Executa(Parametros, Query);
         Alterou := false;
         Result := true;
       end;
    end;
  end;
end;
function TProjeto.RetornaECC_EFC(const PGeraCodigo: string): string;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  with D_Modelo.QrConsulta do
    begin
      Close;
      ParamByName('CODIGO').AsString := PGeraCodigo;
      Open;
    end;
       FECC   := D_Modelo.QrConsulta.fieldByName('ECC').AsString;
       FECF   := D_Modelo.QrConsulta.fieldByName('ECF').AsString;
end;
{ TArea }

procedure TArea.AtualizaCascataSigla(const PGeraCodigo: string; const OldPSigla: string;
  NewPSigla: string);
begin
  conexao.SqlCommand('UPDATE AREA SET SIGLA = ' + QuotedStr(NewPSigla) +
         ' WHERE SIGLA = ' + QuotedStr(OldPSigla) +
         ' AND GERA_CODIGO = ' + QuotedStr(PGeraCodigo));
  conexao.SqlCommand('UPDATE DEMANDAS SET SIGLA = ' + QuotedStr(NewPSigla) +
         ' WHERE SIGLA = ' + QuotedStr(OldPSigla) +
         ' AND GERA_CODIGO = ' + QuotedStr(PGeraCodigo));
end;
function TArea.BuscarInstanciaNoBanco(const PSigla: string; const PGera_Codigo: string): boolean;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  Result := False;
  with D_Modelo.QrConsultaArea do
    begin
      Close;
      ParamByName('SIGLA').AsString := PSigla;
      ParamByName('Gera_Codigo').AsString := PGera_Codigo;
      Open;
      Result := (D_Modelo.QrConsultaArea.RecordCount <> 0);
{     if Result then
      begin
      FSigla   := D_Modelo.QrConsultaArea.fieldByName('SIGLA').AsString;
      FNome := D_Modelo.QrConsultaArea.fieldByName('NOME').AsString;
      FRepresentante := D_Modelo.QrConsultaArea.fieldByName('REPRESENTANTE').AsString;
      FMatricula := D_Modelo.QrConsultaArea.fieldByName('MATRICULA').AsString;
      end; }
      end;
      Alterou := False;

end;
function TArea.BuscarInstanciaNoBancoStringGrid(const PSigla,
  PGera_Codigo: string): boolean;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  Result := False;
  with D_Modelo.QrConsultaArea do
    begin
      Close;
      ParamByName('SIGLA').AsString := PSigla;
      ParamByName('Gera_Codigo').AsString := PGera_Codigo;
      Open;
      Result := (D_Modelo.QrConsultaArea.RecordCount <> 0);
     if Result then
      begin
      FSigla   := D_Modelo.QrConsultaArea.fieldByName('SIGLA').AsString;
      FNome := D_Modelo.QrConsultaArea.fieldByName('NOME').AsString;
      FRepresentante := D_Modelo.QrConsultaArea.fieldByName('REPRESENTANTE').AsString;
      FMatricula := D_Modelo.QrConsultaArea.fieldByName('MATRICULA').AsString;
      end;
      end;
      Alterou := False;
 
end;
function TArea.CarregaDadosComboBox(var strRes: TCombobox;
  Query: string): Boolean;
var
  i: Integer;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
function TArea.CarregaDadosEmUmaVariavel(var Str: string;
  Query: string): Boolean;
var
  i: Integer;
begin
  Str := EmptyStr;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          Str := (Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
function TArea.CarregaDadosStringGrid(var strRes: TStringGrid;
  Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);

end;

constructor TArea.Create(const parmDataBaseName: string);
begin
  conexao := TConexao.create;
end;
destructor TArea.Destroy;
begin
  if Alterou then
    Persistir(Gera_Codigo,TotalRegistros) ;
    conexao.Free;
    inherited Destroy;
end;
procedure TArea.Executa(parm: array of String; Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;

function TArea.NaoPersistir(const parmSigla: string; const parmGera_Codigo: string): boolean;
var
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  FSigla: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  with D_Modelo.QrConsultaArea do
    begin
      Close;
      ParamByName('Sigla').AsString := parmSigla;
      ParamByName('Gera_Codigo').AsString := parmGera_Codigo;
      Open;
    end;
   Result := (D_Modelo.QrConsultaArea.RecordCount <> 0);
   if Result then
   begin
     SetLength(Parametros, 2);
     Query := 'DELETE FROM AREA WHERE SIGLA =:VAL01 AND GERA_CODIGO =:VAL02';
     IndPar := 0;
     CarregaParam(parmSigla);
     CarregaParam(parmGera_Codigo);
     Executa(Parametros, Query);
   end
   else
   begin
     Frc := ProNaoEncontrouSigla;
     FMensagem := 'A Sigla informada no existe';
   end;

end;
function TArea.Persistir(const Value: String; const TotalRegistros: integer): boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  FSigla: string;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  fGera_Codigo :=  Value;
  FTotalRegistros := TotalRegistros;
  query := 'SELECT COUNT(*) FROM AREA WHERE GERA_CODIGO = ' + QuotedStr(Gera_Codigo);
  str := RetornaDadosEmUmaVariavel(str,query);
  setSigla(Sigla);
  if not rc = proNormal then exit;
  setNome(Nome);
  if not rc = proNormal then exit;
  setRepresentante(Representante);
  if not rc = proNormal then exit;
  setMatricula(Matricula);
  if not rc = proNormal then exit;
  // FSigla := RetornaSigla(Sigla,Gera_Codigo);
  // if FSigla <> EmptyStr then
  // begin
   Result := BuscarInstanciaNoBanco(Sigla,Gera_Codigo);
   if Result then
     begin
   SetLength(Parametros, 6);
    Query := 'UPDATE AREA SET NOME = :VALOR01, REPRESENTANTE = :VALOR02, ' +
    'MATRICULA = :VALOR03 ' +
    'WHERE SIGLA = :VALOR04 AND GERA_CODIGO =:VALOR05';
    Parametros[3] := Sigla;
    Parametros[4] := Gera_Codigo;
    IndPar := 0;
    CarregaParam(Nome);
    CarregaParam(Representante);
    CarregaParam(Matricula);
    //CarregaParam(Gera_Codigo);
    Executa(Parametros, Query);
    Alterou := false;
    Result := true;
    end
    else
    begin
      if  StrToIntDef(str, 0) >= TotalRegistros then
        begin
          Application.MessageBox(Pchar(Format(EValorMaximoPermitido,[TotalRegistros])),'Informao',
          MB_OK+MB_ICONWARNING);
          exit;
        end;
      SetLength(Parametros, 5);
      Query := 'INSERT INTO AREA (SIGLA, NOME, REPRESENTANTE, MATRICULA, GERA_CODIGO)' +
      ' VALUES (:VAL01, :VAL02, :VAL03, :VAL04, :VAL05)' ;
      IndPar := 0;
      CarregaParam(Sigla);
      CarregaParam(Nome);
      CarregaParam(Representante);
      CarregaParam(Matricula);
      CarregaParam(Gera_Codigo);
      Executa(Parametros, Query);
      Alterou := False;
      Result := True;
    end;
end;
class function TArea.ProcuraSigla(const PSigla,
  parmDataBaseName: string): boolean;
var
  Area: TArea;
begin
  Area := TArea.Create;
  try
  @veExiste := GetProcAddress(LibInstance, 'VeExiste');
    if @veExiste = nil then
      begin
        Application.MessageBox(PChar(EErroInterno) ,ETitle,MB_OK+MB_ICONERROR);
        FreeLibrary(LibInstance);
      end;
    if VeExiste ('AREA WHERE SIGLA = ' + QuotedStr(PSigla)) then
    Result := True
    else
    Result := False;
    finally
    Area.Free;
    end;
end;

function TArea.RetornaDadosEmUmaVariavel(var Str: string;
  Query: string): string;
var
  i: Integer;
begin
  Str := EmptyStr;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          Str := (Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := Str;
    Close;
  end;
end;
class function TArea.RetornaSigla(const PSigla: string; const PGera_Codigo: string): string;
begin
  with D_Modelo.QrConsultaArea do
    begin
      Close;
      ParamByName('SIGLA').AsString := PSigla;
      ParamByName('Gera_Codigo').AsString := PGera_Codigo;
      Open;
      Result := D_Modelo.QrConsultaArea.fieldByName('SIGLA').AsString;
    end;
end;
procedure TArea.setMatricula(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Matrcula';
  end
  else
  begin
    FMatricula := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TArea.setNome(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Nome';
  end
  else
  begin
    FNome := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TArea.setRepresentante(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Representante';
  end
  else
  begin
    FRepresentante := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TArea.setSigla(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Sigla';
  end
  else
  begin
    FSigla := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TArea.SetStatus(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Status';
  end
  else
  begin
    FStatus := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
{ TConexao }
function TConexao.AbreBanco: boolean;
begin
  @AbreModelo := GetProcAddress(LibInstance, 'AbreModelo');
  if @AbreModelo = nil then
    begin
      Application.MessageBox(PChar(EErroInterno) ,ETitle,MB_OK+MB_ICONERROR);
      if LibInstance <> 0 then
      begin
        FreeLibrary(LibInstance);
        result := false;
        exit;
      end;
    end;
  AbreModelo;
  result := true;
end;
function TConexao.CarregaBanco: boolean;
begin
 Result := False;
  LibInstance := 0;
  PathCfgIni := (ExtractFilePath(Application.ExeName) + CFGName);
  if not FileExists(PathCfgIni) then
    begin
      Application.MessageBox(PChar(format(ECaminhoInvalido,[CFGName])),ETitle,MB_OK+MB_ICONERROR);
      exit;
    end;
  try
    ini := TIniFile.Create(ExtractFilePath(Application.ExeName) + CFGName);
    PathDLL := Ini.ReadString('DLLPath','Path',PathDLL);
    if (PathDLL <> 'A:\') or (PathDLL <> 'B:\') or (PathDLL <> 'C:\') or (PathDLL <> 'D:\')
    or (PathDLL <> 'E:\') or (PathDLL <> 'F:\') or (PathDLL <> 'G:\') or (PathDLL <> 'H:\')
    or (PathDLL <> 'I:\') or (PathDLL <> 'J:\') or (PathDLL <> 'K:\') or (PathDLL <> 'L:\')
    or (PathDLL <> 'M:\') or (PathDLL <> 'N:\') or (PathDLL <> 'O:\') or (PathDLL <> 'P:\')
    or (PathDLL <> 'Q:\') or (PathDLL <> 'R:\') or (PathDLL <> 'S:\') or (PathDLL <> 'T:\')
    or (PathDLL <> 'U:\') or (PathDLL <> 'V:\') or (PathDLL <> 'W:\') or (PathDLL <> 'X:\')
    or (PathDLL <> 'Y:\') or (PathDLL <> 'Z:\')
    then
    PathDLL := Ini.ReadString('DLLPath','Path',PathDLL) + '\'+ ProDLLName
    else
    PathDLL := Ini.ReadString('DLLPath','Path',PathDLL) + ProDLLName;
  finally
    Ini.Free;
  end;
  if (LibInstance = 0) then
    LibInstance := LoadLibrary(pchar(PathDLL));
  if LibInstance = 0 then
    begin
      Application.MessageBox(PChar(format(ECaminhoInvalido,[ProDLLName])),ETitle,MB_OK+MB_ICONERROR);
      exit;
    end;
    if AbreBanco then Result := True;
end;
constructor TConexao.create;
begin
  if not CarregaBanco then
  Application.MessageBox(Pchar(Format(EErroBancoDeDados,[CFGName])),
  ETitleOK,MB_OK+MB_ICONWARNING);
end;
destructor TConexao.destroy;
begin
 if not FechaBanco then Application.MessageBox(ErroAoFecharBanco,ETitle,MB_OK+MB_ICONWARNING);
  inherited Destroy;
end;
function TConexao.FechaBanco: boolean;
begin
  @FechaModelo := GetProcAddress(LibInstance, 'FechaModelo');
  if @FechaModelo = nil then
    begin
      Application.MessageBox(PChar(EErroInterno) ,ETitle,MB_OK+MB_ICONERROR);
      if LibInstance <> 0 then
      begin
        FreeLibrary(LibInstance);
        result := false;
        exit;
      end;
    end;
  FechaModelo;
  Result := true;
end;
class procedure TConexao.SqlCommand(const Query: string);
begin
  with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(Query);
      ExecSQL;
    end;
end;
{ TDemanda }

function TDemanda.BuscarInstanciaNoBanco(const PNumero: string; const PGera_Codigo: string): boolean;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  Result := False;
  with D_Modelo.QrRetornaDadosInstanciaDemanda do
    begin
      Close;
      ParamByName('NUMERO').Asstring := PNumero;
      ParamByName('GERA_CODIGO').AsString := PGera_Codigo;
      Open;
      Result := (D_Modelo.QrRetornaDadosInstanciaDemanda.RecordCount <> 0);
      if Result then
      begin
      FSigla   := D_Modelo.QrRetornaDadosInstanciaDemanda.fieldByName('SIGLA').AsString;
      FDescricao := D_Modelo.QrRetornaDadosInstanciaDemanda.fieldByName('DESCRICAO').AsString;
      FNumero := D_Modelo.QrRetornaDadosInstanciaDemanda.fieldByName('NUMERO').AsString;
      //FGera_Codigo := D_Modelo.QrRetornaDadosInstanciaDemanda.fieldByName('GERA_CODIGO').AsString;
      end;
      end;
      Alterou := False;

end;
function TDemanda.CarregaDadosComboBox(var strRes: TCombobox;
  Query: string): Boolean;
var
  i: Integer;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
function TDemanda.CarregaDadosStringGrid(var strRes: TStringGrid;
  Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);
end;
constructor TDemanda.Create(const parmDataBaseName: string);
begin
  conexao := TConexao.create;
end;
destructor TDemanda.Destroy;
begin
  if Alterou then
    Persistir(Numero, Gera_Codigo, TotalRegistros) ;
  conexao.Free;
  inherited Destroy;
end;
procedure TDemanda.Executa(parm: array of String; Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;
function TDemanda.NaoPersistir(const Value: string; const ParmGera_Codigo: string): boolean;
var
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  with D_Modelo.QrConsultaDemanda do
    begin
      Close;
      ParamByName('Numero').AsString := Value;
      ParamByName('Gera_Codigo').AsString := parmGera_Codigo;
      Open;
    end;
   Result := (D_Modelo.QrConsultaDemanda.RecordCount <> 0);
   if Result then
   begin
     Query := 'DELETE FROM DEMANDAS WHERE NUMERO =:VAL01 AND GERA_CODIGO =:VAL02';
     IndPar := 0;
     SetLength(Parametros, 2);
     CarregaParam(Value);
     CarregaParam(parmGera_Codigo);
     Executa(Parametros, Query);
   end
   else
   begin
     Frc := ProNaoEncontrouNumero;
     FMensagem := 'O Nmero informado no existe';
   end;
 
end;
 
class function TDemanda.NumeroExiste(const PNumero: String;
  const PGera_Codigo: string): boolean;
begin
with D_Modelo.QrRetornaDadosInstanciaDemanda do
    begin
      Close;
      ParamByName('NUMERO').AsString := PNumero;
      ParamByName('GERA_CODIGO').AsString := PGera_Codigo;
      Open;
      Result := (D_Modelo.QrRetornaDadosInstanciaDemanda.RecordCount <> 0);
    end;
end;
function TDemanda.Persistir(const PNumero: String; const PGera_Codigo: string; const TotalRegistros: integer): boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  FSigla: string;
  ParamNumero: string;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  FNumero := PNumero;
  FGera_Codigo :=  PGera_Codigo;
  FTotalRegistros := TotalRegistros;
  query := 'SELECT COUNT(*) FROM DEMANDAS WHERE GERA_CODIGO = ' + QuotedStr(Gera_Codigo);
  str := RetornaDadosEmUmaVariavel(str,query);
  setSigla(Sigla);
  if not rc = proNormal then exit;
  setDescricao(Descricao);
  if not rc = proNormal then exit;
  SetNumero(Numero);
  if not rc = proNormal then exit;
  Result := NumeroExiste(Numero, Gera_Codigo);
  if Result then
   begin
   SetLength(Parametros, 4);
    Query := 'UPDATE DEMANDAS SET DESCRICAO = :VALOR01, SIGLA = :VALOR02 ' +
    ' WHERE GERA_CODIGO = :VALOR03 ' +
    ' AND NUMERO = :VALOR04';
    Parametros[2] := Gera_Codigo;
    Parametros[3] := Numero;
    IndPar := 0;
    CarregaParam(Descricao);
    CarregaParam(Sigla);
    Executa(Parametros, Query);
     Alterou := false;
     Result := true;
    end
    else
    begin
    if  StrToIntDef(str, 0) >= TotalRegistros then
      begin
        Application.MessageBox(Pchar(Format(EValorMaximoPermitido,[TotalRegistros])),'Informao',
        MB_OK+MB_ICONWARNING);
        exit;
      end;
      SetLength(Parametros, 4);
      Query := 'INSERT INTO DEMANDAS (DESCRICAO, NUMERO, GERA_CODIGO, SIGLA)' +
      ' VALUES (:VAL01, :VAL02, :VAL03, :VAL04)' ;
      IndPar := 0;
      CarregaParam(Descricao);
      CarregaParam(Numero);
      CarregaParam(Gera_Codigo);
      CarregaParam(Sigla);
      Executa(Parametros, Query);
      Alterou := False;
      Result := True;
    end;
end;
class function TDemanda.ProcuraArea(const PArea,
  parmDataBaseName: string): boolean;
begin
end;
class function TDemanda.ProcuraNumero(const PNumero: String;
  const parmDataBaseName: string): boolean;
begin
end;
function TDemanda.RetornaDadosEmUmaVariavel(var Str: string;
  Query: string): string;
var
  i: Integer;
begin
  Str := EmptyStr;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          Str := (Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := Str;
    Close;
  end;

end;
class function TDemanda.RetornaNumero(const PNumero: String;
  const PGera_Codigo: string): boolean;
begin
  with D_Modelo.QrConsultaDemanda do
    begin
      Close;
      ParamByName('NUMERO').AsString := PNumero;
      ParamByName('GERA_CODIGO').AsString := PGera_Codigo;
      Open;
      Result := D_Modelo.QrConsultaDemanda.RecordCount <> 0;
    end;
end;
procedure TDemanda.setDescricao(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Descrio';
  end
  else
  begin
    FDescricao := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TDemanda.SetNumero(const Value: String);
begin
  if Value = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Nmero';
  end
  else
  begin
    FNumero := Value;
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TDemanda.setSigla(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Sigla';
  end
  else
  begin
    FSigla := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
{ TDimensao }
function TDimensao.CarregaDadosComboBox(var strRes: TCombobox;
  Query: string): Boolean;
var
  i: Integer;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
function TDimensao.CarregaDadosListBox(var strRes: TListBox;
  Query: string): Boolean;
var
  i: Integer;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
constructor TDimensao.Create(const parmDataBaseName: string);
begin
  conexao := TConexao.Create;
end;
destructor TDimensao.Destroy;
begin
  conexao.Free;
  inherited Destroy;
end;
procedure TDimensao.setDimensao(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Dimenso';
  end
  else
  begin
    FDimensao := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
{ TDimensaoPeso }
{constructor TDimensaoPeso.Create(const parmDataBaseName: string);
begin
  conexao := TConexao.create;
end;
destructor TDimensaoPeso.Destroy;
begin
  conexao.Free;
  inherited Destroy;
end;
}
function TDimensaoPeso.CarregaDadosDimensaoPeso(var strRes: TListBox;
  Query: string): Boolean;
var
  i: Integer;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(Fields[i].AsString);
        //  showmessage(Fields[0].AsString+ ' ' + Fields[1].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
function TDimensaoPeso.CarregaDadosStringGrid(var strRes: TStringGrid;
  Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);
end;
procedure TDimensaoPeso.Executa(parm: array of String; Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;

function TDimensaoPeso.NaoPersistir(const PGera_Codigo,
  PDescricao_Dimensao: string): Boolean;
var
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  Frc := ProNormal;
  FMensagem := EmptyStr;
  Result := TDimensaoPeso.ProjetoExisteComMesmaDimensao(PGera_Codigo, PDescricao_Dimensao);
  if Result then
    begin
      SetLength(Parametros, 2);
      Query := 'DELETE FROM DIMENSAO_PESO WHERE CODIGO_PROJETO =:VAL01 AND DESCRICAO_DIMENSAO =:VAL02';
      IndPar := 0;
      CarregaParam(PGera_Codigo);
      CarregaParam(PDescricao_Dimensao);
      Executa(Parametros, Query);
   end
   else
   begin
     Frc := ProNaoEncontrouSigla;
     FMensagem := 'No existem cadastrados os dados'#13#10'de Projeto '+
     PGera_Codigo+ ' com a Dimenso ' + PDescricao_Dimensao+ '.';
   end;
end;
function TDimensaoPeso.Persistir(const PGera_Codigo: string;
  const PDescricao_Dimensao: string; const Peso: string): boolean;
var
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  if (PDescricao_Dimensao = EmptyStr) or (Peso = EmptyStr) then
    begin
      Result := False;
      Exit;
    end;
  Result := TDimensaoPeso.ProjetoExisteComMesmaDimensao(PGera_Codigo, PDescricao_Dimensao);
  if not Result then {
    begin
     SetLength(Parametros, 2);
     Query := 'UPDATE DIMENSAO_PESO SET DESCRICAO_DIMENSAO =:VAL01 ' +
     'WHERE CODIGO_PROJETO =:VAL02';
     Parametros[1] := PGera_Codigo;
     IndPar := 0;
     CarregaParam(PDescricao_Dimensao);
     Executa(Parametros, Query);
    end
    else }
    begin
    SetLength(Parametros, 4);
    Query := 'INSERT INTO DIMENSAO_PESO (CODIGO_PROJETO, DESCRICAO_DIMENSAO, PESO)' +
    ' VALUES (:VAL01, :VAL02, :VAL03)' ;
    IndPar := 0;
    CarregaParam(PGera_Codigo);
    CarregaParam(PDescricao_Dimensao);
    CarregaParam(Peso);
    Executa(Parametros, Query);
    Alterou := False;
    Result := True;
    end;
end;
class function TDimensaoPeso.ProjetoExiste(
  const PGera_Codigo: String): boolean;
begin
  with D_Modelo.QrConsultaDimensaoPeso do
    begin
      Close;
      ParamByName('CODIGOPROJETO').AsString := PGera_Codigo;
      Open;
      Result := D_Modelo.QrConsultaDimensaoPeso.RecordCount <> 0;
    end;
end;
class function TDimensaoPeso.ProjetoExisteComMesmaDimensao(
  const PGera_Codigo, PDescricaoDimensao: string): boolean;
begin
  with D_Modelo.QrConsultaExisteProjetoComMesmaDimensao do
    begin
      Close;
      ParamByName('CODIGOPROJETO').AsString := PGera_Codigo;
      ParamByName('DESCRICAODIMENSAO').AsString := PDescricaoDimensao;
      Open;
      Result := D_Modelo.QrConsultaExisteProjetoComMesmaDimensao.RecordCount <> 0;
    end;
end;
function TDimensaoPeso.Selecionar(const PGera_Codigo: string): boolean;
begin
end;
procedure TDimensaoPeso.SetPeso(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Peso';
  end
  else
  begin
    FDimensao := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
{ TVariavel }
function TVariavel.BuscarInstanciaNoBanco(const PDescricaoDimensao,
  PDescricaoVariavel: string): string;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
    with D_Modelo.QrConsultaVariavel do
    begin
      Close;
      ParamByName('DESCRICAODIMENSAO').AsString := PDescricaoDimensao;
      ParamByName('DESCRICAOVARIAVEL').AsString := PDescricaoVariavel;
      Open;
      FCodigo := D_Modelo.QrConsultaVariavel.fieldByName('CODIGOCONTROLE').AsString;
      FDescricaoDimensao := D_Modelo.QrConsultaVariavel.fieldByName('DESCRICAO_DIMENSAO').AsString;
      FDescricaoVariavel := D_Modelo.QrConsultaVariavel.fieldByName('DESCRICAO_VARIAVEL').AsString;
      Result := FCodigo;
      end;
end;
function TVariavel.CarregaDadosComboBox(var strRes: TCombobox;
  Query: string): Boolean;
var
  i: Integer;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
function TVariavel.CarregaDadosStringGrid(var strRes: TStringGrid;
  Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);
end;
constructor TVariavel.Create(const parmDataBaseName: string);
begin
  conexao := TConexao.create;
end;
destructor TVariavel.Destroy;
begin
  if Alterou then
    Persistir(DescricaoDimensao, DescricaoVariavel) ;
    conexao.Free;
    inherited Destroy;
end;
procedure TVariavel.Executa(parm: array of String; Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;
class function TVariavel.ExisteDimensaoComVariavel(const PDescricaDimensao,
  PDescricaoVariavel: string): boolean;
begin
  Result := False;
  with D_Modelo.QrConsultaVariavel do
    begin
      Close;
      ParamByName('DESCRICAODIMENSAO').AsString := PDescricaDimensao;
      ParamByName('DESCRICAOVARIAVEL').AsString := PDescricaoVariavel;
      Open;
    end;
    Result := (D_Modelo.QrConsultaVariavel.RecordCount <> 0);
end;
class function TVariavel.ExisteDimensao(const PDescricaDimensao: string): boolean;
begin
  Result := False;
  with D_Modelo.QrDimensaoExisteCadastradaEmVariavel do
    begin
      Close;
      ParamByName('DESCRICAODIMENSAO').AsString := UpperCase(PDescricaDimensao);
      Open;
    end;
    Result := (D_Modelo.QrConsultaVariavel.RecordCount <> 0);
end;
class function TVariavel.ExisteVariavel(const PDescricaoVariavel: string): boolean;
begin
  Result := False;
  with D_Modelo.QrExisteVariavel do
    begin
      Close;
      ParamByName('DESCRICAOVARIAVEL').AsString := PDescricaoVariavel;
      Open;
    end;
    Result := (D_Modelo.QrExisteVariavel.RecordCount <> 0);
end;
 
function TVariavel.NaoPersistir(const PDescricaoVariavel: string): boolean;
var
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  FSigla: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  FDescricaoVariavel := PDescricaoVariavel;
  Result := TVariavel.ExisteVariavel(FDescricaoVariavel);
  if Result then
  begin
     SetLength(Parametros, 2);
     Query := 'DELETE FROM VARIAVEL WHERE DESCRICAO_VARIAVEL =:VAL01';
     IndPar := 0;
     CarregaParam(DescricaoVariavel);
     Executa(Parametros, Query);
   end
   else
   begin
     Frc := ProNaoEncontrouVariavel;
     FMensagem := 'A Varivel informada no existe';
   end;
end;
function TVariavel.Persistir(const PDescricaDimensao: string; const PDescricaoVariavel: string): boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  PCodigo: string;
  fCodigoControleparaInsercao: string;
  i: integer;
  const n = '1234567890';
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  FDescricaoDimensao := PDescricaDimensao;
  FDescricaoVariavel := PDescricaoVariavel;
  setDescricaoVariavel(DescricaoVariavel);
  if not rc = proNormal then exit;
  Result := ExisteDimensaoComVariavel(DescricaoDimensao,DescricaoVariavel);
  if Result then
    begin
    PCodigo := BuscarInstanciaNoBanco(DescricaoDimensao,DescricaoVariavel);
    SetLength(Parametros, 2);
    Query := 'DELETE FROM VARIAVEL WHERE CODIGOCONTROLE = :VALOR01';
    IndPar := 0;
    CarregaParam(PCodigo);
   { Query := 'UPDATE VARIAVEL SET DESCRICAO_VARIAVEL = :VALOR01 '+
    'WHERE CODIGOCONTROLE = :VALOR02';
    Parametros[1] := PCodigo;
    IndPar := 0;
    CarregaParam(DescricaoVariavel);
    }
    Executa(Parametros, Query);
    Alterou := false;
    Result := true;
 //Prepara e manda a CPU gerar um valor de cdigo de controle aleatrio (1O dgitos)...
    for i := 0 to 9 do
      fCodigoControleparaInsercao :=
      fCodigoControleparaInsercao + n[Random(length(n)-1)+1];
    SetLength(Parametros, 3);
    Query := 'INSERT INTO VARIAVEL (DESCRICAO_DIMENSAO, DESCRICAO_VARIAVEL, CODIGOCONTROLE)' +
    ' VALUES (:VAL01, :VAL02, :VAL03)' ;
    IndPar := 0;
    CarregaParam(FDescricaoDimensao);
    CarregaParam(FDescricaoVariavel);
    CarregaParam(fCodigoControleparaInsercao);
    Executa(Parametros, Query);
    Alterou := false;
    Result := true;
    end
    else
    begin
      //Prepara e manda a CPU gerar um valor de cdigo de controle aleatrio (1O dgitos)...
      for i := 0 to 9 do
        fCodigoControleparaInsercao :=
        fCodigoControleparaInsercao + n[Random(length(n)-1)+1];
      SetLength(Parametros, 3);
      Query := 'INSERT INTO VARIAVEL (DESCRICAO_DIMENSAO, DESCRICAO_VARIAVEL, CODIGOCONTROLE)' +
      ' VALUES (:VAL01, :VAL02, :VAL03)' ;
      IndPar := 0;
      CarregaParam(FDescricaoDimensao);
      CarregaParam(FDescricaoVariavel);
      CarregaParam(fCodigoControleparaInsercao);
      Executa(Parametros, Query);
      Alterou := False;
      Result := True;
    end;
end;
procedure TVariavel.setDescricaoVariavel(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Varivel';
  end
  else
  begin
    FDescricaoVariavel := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
function TVariavel.BuscarInstanciasDaVariavel(
  const PDescricaoVariavel: string): boolean;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  Result := False;
    with D_Modelo.QrExisteVariavel do
    begin
      Close;
      ParamByName('DESCRICAOVARIAVEL').AsString := UpperCase(PDescricaoVariavel);
      Open;
      Result := (D_Modelo.QrExisteVariavel.RecordCount <> 0);
      FCodigo := D_Modelo.QrExisteVariavel.fieldByName('CODIGOCONTROLE').AsString;
      FDescricaoDimensao := D_Modelo.QrExisteVariavel.fieldByName('DESCRICAO_DIMENSAO').AsString;
      FDescricaoVariavel := D_Modelo.QrExisteVariavel.fieldByName('DESCRICAO_VARIAVEL').AsString;
    end;
end;
{ Variaveis_Projeto }
function TVariaveis_Projeto.BuscarInstanciaNoBanco(const PGeraCodigo,
  PDescricaoVariavel: string): string;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  with D_Modelo.QrConsultaVariavelProjeto do
  begin
    Close;
    ParamByName('GERACODIGO').AsString := PGeraCodigo;
    ParamByName('DESCRICAOVARIAVEL').AsString := PDescricaoVariavel;
    Open;
    FGera_Codigo := D_Modelo.QrConsultaVariavelProjeto.fieldByName('GERA_CODIGO').AsString;
    FDescricaoDimensao := D_Modelo.QrConsultaVariavelProjeto.fieldByName('DESCRICAO_DIMENSAO').AsString;
    FDescricaoVariavel := D_Modelo.QrConsultaVariavelProjeto.fieldByName('DESCRICAO_VARIAVEL').AsString;
    FMarcado := D_Modelo.QrConsultaVariavelProjeto.FieldByName('MARCADO').AsBoolean;
    Result := FDescricaoVariavel;
    end;
end;
function TVariaveis_Projeto.BuscarInstanciasDaVariavel(const PGeraCodigo,
  PDescricaoVariavel: string): string;
var resultado: string;
begin
  resultado := BuscarInstanciaNoBanco(PGeraCodigo,PDescricaoVariavel);
end;
function TVariaveis_Projeto.CarregaDadosCheckListBox(
  var strRes: TCheckListBox; Query: string): Boolean;
var
  i: Integer;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
function TVariaveis_Projeto.CarregaDadosComboBox(var strRes: TCombobox;
  Query: string): Boolean;
var
  i: Integer;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;

end;
function TVariaveis_Projeto.CarregaDadosStringGrid(var strRes: TStringGrid;
  Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);
  
end;
function TVariaveis_Projeto.CarregaDimensoes_e_VariaveisSelecionadas(const PGeraCodigo: string;
  var strRes: TtreeView): Boolean;
var
  i: Integer;
  FSQL: string;
  No, NoFilho, NoCampos: TTreeNode;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  FSQL := 'SELECT DESCRICAO FROM DEMANDAS WHERE GERA_CODIGO = ' + QuotedStr(PGeraCodigo) +
  ' ORDER BY 1';
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(FSQL);
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(nil, Fields[0].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
function TVariaveis_Projeto.CarregaVariaveisNaoSelecionadas(
  var strRes: TCheckListBox; Query: string): Boolean;
var
  i: Integer;
  FSQL: string;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  FSQL := 'SELECT DESCRICAO_VARIAVEL, MARCADO FROM VARIAVEIS_PROJETO '#13#10+
  'WHERE GERA_CODIGO = ' + QuotedStr(Query) +
  ' ORDER BY 1';
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(FSQL);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
       // for i := 0 to FieldCount-1 do
       if not (Fields[1].AsBoolean) then
          strRes.Items.Add(Fields[0].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
 
end;
function TVariaveis_Projeto.CarregaVariaveisNaoSelecionadasSemEsvaziar(
  var strRes: TCheckListBox; Query: string): Boolean;
var
  i: Integer;
  FSQL: string;
begin
  FSQL := 'SELECT DESCRICAO_VARIAVEL, MARCADO FROM VARIAVEIS_PROJETO '#13#10+
  'WHERE GERA_CODIGO = ' + QuotedStr(Query) +
  ' ORDER BY 1';
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(FSQL);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
       // for i := 0 to FieldCount-1 do
       if not (Fields[1].AsBoolean) then
          strRes.Items.Add(Fields[0].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;

end;
function TVariaveis_Projeto.CarregaVariaveisSelecionadas(
  var strRes: TCheckListBox; Query: string): Boolean;
var
  i: Integer;
  FSQL: string;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  FSQL := 'SELECT DESCRICAO_VARIAVEL, MARCADO FROM VARIAVEIS_PROJETO '#13#10+
  'WHERE GERA_CODIGO = ' + QuotedStr(Query) +
  ' ORDER BY 1';
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(FSQL);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
       // for i := 0 to FieldCount-1 do
       if Fields[1].AsBoolean then
          strRes.Items.Add(Fields[0].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
constructor TVariaveis_Projeto.Create(const parmDataBaseName: string);
begin
  conexao := TConexao.Create;
end;
function TVariaveis_Projeto.Desmarcar(const PGeraCodigo,
  PDescricaoVariavel: string): boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  //FSigla: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;

  fGera_Codigo :=  PGeraCodigo;
  FDescricaoVariavel := PDescricaoVariavel;
  Result := TVariaveis_Projeto.ExisteVariavel(Gera_Codigo,DescricaoVariavel);
  if Result then
   SetLength(Parametros, 3);
    Query := 'UPDATE VARIAVEIS_PROJETO SET MARCADO = FALSE'#13#10 +
    'WHERE GERA_CODIGO = :VALOR01'#13#10 +
    'AND DESCRICAO_VARIAVEL =:VAL02';
    IndPar := 0;
    CarregaParam(Gera_Codigo);
    CarregaParam(DescricaoVariavel);
    Executa(Parametros, Query);
     Alterou := false;
     Result := true;
end;
destructor TVariaveis_Projeto.Destroy;
begin
  if Alterou then
    Persistir(Gera_Codigo, DescricaoDimensao, DescricaoVariavel, TotalRegistros) ;
    conexao.Free;
    inherited Destroy;
end;
procedure TVariaveis_Projeto.Executa(parm: array of String; Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;
class function TVariaveis_Projeto.ExisteVariavel(const PGeraCodigo,
  PDescricaoVariavel: string): boolean;
begin
  Result := False;
  with D_Modelo.QrConsultaVariavelProjeto do
    begin
      Close;
      ParamByName('GERACODIGO').AsString := PGeraCodigo;
      ParamByName('DESCRICAOVARIAVEL').AsString := PDescricaoVariavel;
      Open;
    end;
  Result := (D_Modelo.QrConsultaVariavelProjeto.RecordCount <> 0);
end;
 
function TVariaveis_Projeto.LocalizaVariavel(const PGeraCodigo,
  PDescricaoVariavel: string): boolean;
begin
end;
function TVariaveis_Projeto.Marcar(const PGeraCodigo,
  PDescricaoVariavel: string): boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  //FSigla: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;

  fGera_Codigo :=  PGeraCodigo;
  FDescricaoVariavel := PDescricaoVariavel;
  Result := TVariaveis_Projeto.ExisteVariavel(Gera_Codigo,DescricaoVariavel);
  if Result then
   SetLength(Parametros, 3);
    Query := 'UPDATE VARIAVEIS_PROJETO SET MARCADO = TRUE'#13#10 +
    'WHERE GERA_CODIGO = :VALOR01'#13#10 +
    'AND DESCRICAO_VARIAVEL =:VAL02';
    IndPar := 0;
    CarregaParam(Gera_Codigo);
    CarregaParam(DescricaoVariavel);
    Executa(Parametros, Query);
     Alterou := false;
     Result := true;
end;
function TVariaveis_Projeto.NaoPersistir(const PGeraCodigo,
  PDescricaoVariavel: string): boolean;
var
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  FSigla: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  FDescricaoVariavel := PDescricaoVariavel;
  FGera_Codigo := PGeraCodigo;
  Result := TVariaveis_Projeto.ExisteVariavel(Gera_Codigo, DescricaoVariavel);
  if Result then
  begin
     SetLength(Parametros, 2);
     Query := 'DELETE FROM VARIAVEIS_PROJETO WHERE DESCRICAO_VARIAVEL =:VAL01'#13#10 +
     'AND GERA_CODIGO =:VAL02';
     IndPar := 0;
     CarregaParam(DescricaoVariavel);
     CarregaParam(Gera_Codigo);
     Executa(Parametros, Query);
   end
   else
   begin
     Frc := ProNaoEncontrouVariavel;
     FMensagem := 'A Varivel informada no existe';
   end;

end;
function TVariaveis_Projeto.Persistir(const PGeraCodigo: string;
 const PDescricaoDimensao: string; const PDescricaoVariavel: string; const TotalRegistros: integer): boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  //FSigla: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;

  fGera_Codigo :=  PGeraCodigo;
  FDescricaoDimensao := PDescricaoDimensao;
  FDescricaoVariavel := PDescricaoVariavel;
  FTotalRegistros := TotalRegistros;
  setDescricaoVariavel(DescricaoVariavel);
  if not rc = proNormal then exit;
  //O mnimo de dimenses permitidas  de 2, o mximo  de 4.
   query := 'SELECT COUNT(DESCRICAO_DIMENSAO)'#13#10 +
  'FROM DIMENSAO_PESO'#13#10+
  'WHERE CODIGO_PROJETO = ' + QuotedStr(Gera_Codigo);
   str := RetornaDadosEmUmaVariavel(str,query);
  if  StrToIntDef(str, 0) < 2 then
       begin
         Application.MessageBox(Pchar(Format(EValorMinimoPermitidoDimensoes,[2])),'Informao',
         MB_OK+MB_ICONWARNING);
         exit;
       end;
  Result := TVariaveis_Projeto.ExisteVariavel(Gera_Codigo,DescricaoVariavel);
  if Result then
    begin
   Application.MessageBox('Erro. J existe Cadastrado.','Ateno',MB_OK+MB_ICONWARNING);
    { SetLength(Parametros, 3);
    Query := 'UPDATE VARIAVEIS_PROJETO SET DESCRICAO_VARIAVEL= :VAL01'
    'WHERE DESCRICAO_VARIAVEL = :VALOR02';
    Parametros[1] := DescricaoVariavel;
    IndPar := 0;
    CarregaParam(Nome);
    CarregaParam(Representante);
    CarregaParam(Matricula);
    CarregaParam(Gera_Codigo);
    Executa(Parametros, Query);
     Alterou := false;
     Result := true; }
    end
    else
    begin
      query := 'SELECT COUNT(*) FROM VARIAVEIS_PROJETO WHERE GERA_CODIGO = ' + QuotedStr(Gera_Codigo) +
      ' AND DESCRICAO_DIMENSAO = ' + QuotedStr(DescricaoDimensao);
      str := RetornaDadosEmUmaVariavel(str,query);
     if  StrToIntDef(str, 0) >= TotalRegistros then
       begin
         Application.MessageBox(Pchar(Format(EValorMaximoPermitido,[TotalRegistros])),'Informao',
         MB_OK+MB_ICONWARNING);
         exit;
       end;
      SetLength(Parametros, 3);
      Query := 'INSERT INTO VARIAVEIS_PROJETO (GERA_CODIGO, DESCRICAO_DIMENSAO, DESCRICAO_VARIAVEL)' +
      ' VALUES (:VAL01, :VAL02, :VAL03)' ;
      IndPar := 0;
      CarregaParam(Gera_Codigo);
      CarregaParam(DescricaoDimensao);
      CarregaParam(DescricaoVariavel);
      Executa(Parametros, Query);
      Alterou := False;
      Result := True;
    end;
end;
function TVariaveis_Projeto.RetornaDadosEmUmaVariavel(var Str: string;
  Query: string): string;
var
  i: Integer;
begin
  Str := EmptyStr;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          Str := (Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := Str;
    Close;
  end;
end;
class function TVariaveis_Projeto.RetornaDimensaoDaVariavelExistente(
  const PGeraCodigo, PDescricaoVariavel: string): string;
begin
  Result := '';
  with D_Modelo.QrConsultaVariavelProjeto do
    begin
      Close;
      ParamByName('GERACODIGO').AsString := PGeraCodigo;
      ParamByName('DESCRICAOVARIAVEL').AsString := PDescricaoVariavel;
      Open;
    end;
  if D_Modelo.QrConsultaVariavelProjeto.RecordCount <> 0 then
  Result := D_Modelo.QrConsultaVariavelProjeto.fieldByName('DESCRICAO_DIMENSAO').AsString;
end;
procedure TVariaveis_Projeto.setDescricaoVariavel(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Varivel';
  end
  else
  begin
    FDescricaoVariavel := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TVariaveis_Projeto.SetMarcado(const Marcado: boolean);
begin
end;
{ TNotas }
function TNotas.CarregaDadosStringGrid(var strRes: TStringGrid;
  Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);
end;
function TNotas.CarregaNotasParaTodasAsDemandas(
  var PClientdataset: TClientDataSet; PGeraCodigo: string): Boolean;
var
  i: Integer;
  Query: string;
begin
   Result := False;
   Query := 'SELECT  V.DESCRICAO_DIMENSAO, V.DESCRICAO_VARIAVEL, D.DESCRICAO'#13#10 +
   'FROM VARIAVEIS_PROJETO V'#13#10 +
   'INNER JOIN DEMANDAS D'#13#10 +
   'ON V.GERA_CODIGO = D.GERA_CODIGO'#13#10+
   'WHERE GERA_CODIGO = ' + QuotedStr(PGeraCodigo)+
   'AND V.MARCADO = TRUE'#13#10 +
   'ORDER BY 1,2,3';
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
    Open;
    Result := (D_Modelo.QrExecuta.RecordCount <> 0);
    PClientdataset.EmptyDataSet;
    PClientdataset.Open;
    if not EOF then begin
      repeat
      // for i := 0 to FieldCount-1 do
       //  begin
           PClientdataset.Append;
           PClientdataset.FieldByName('DESCRICAO_DIMENSAO').AsString := Fields[0].AsString;
           PClientdataset.FieldByName('DESCRICAO_VARIAVEL').AsString := Fields[1].AsString;
           PClientdataset.FieldByName('DESCRICAO').AsString := Fields[2].AsString;
           PClientdataset.Post;
          //strRes.Items.Add(Fields[i].AsString);
        // end;
       Next;
      until EOF;
      
    end;
    Close;
    PClientdataset.Filtered := False;
  end;
 // Result := ;
end;
constructor TNotas.Create(const parmDataBaseName: string);
begin
  conexao := TConexao.Create;
end;
destructor TNotas.Destroy;
begin
 // if Alterou then
  //  Persistir(Gera_Codigo, DescricaoDimensao, DescricaoVariavel, TotalRegistros) ;
    conexao.Free;
    inherited Destroy;
end;
procedure TNotas.Executa(parm: array of String; Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;

end;

function TNotas.Persistir(const PGeraCodigo, PDescricaoDemandas,
  PDescricaoDimensao, PDescricaoVariavel: string; const PNota: integer): boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  //FSigla: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  FGera_Codigo :=  PGeraCodigo;
  FDescricaoDemanda := PDescricaoDemandas;
  FDescricaoDimensao := PDescricaoDimensao;
  FDescricaoVariavel := PDescricaoVariavel;
  setNota(PNota);
  if not rc = proNormal then exit;
  SetLength(Parametros, 6);
  Query := 'INSERT INTO NOTAS (GERA_CODIGO, DESCRICAO_DEMANDA, DESCRICAO_DIMENSAO, DESCRICAO_VARIAVEL, NOTA)' +
  ' VALUES (:VAL01, :VAL02, :VAL03, :VAL04, :VAL05)' ;
  IndPar := 0;
  CarregaParam(Gera_Codigo);
  CarregaParam(DescricaoDemanda);
  CarregaParam(DescricaoDimensao);
  CarregaParam(DescricaoVariavel);
  CarregaParam(IntToStr(Notas));
  Executa(Parametros, Query);
  Alterou := False;
  Result := True;
end;
procedure TNotas.RemoveNotas(const PGeraCodigo: string);
var
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  SetLength(Parametros, 2);
  Query := 'DELETE FROM NOTAS WHERE GERA_CODIGO =:VAL01';
  IndPar := 0;
  CarregaParam(PGeraCodigo);
  Executa(Parametros, Query);

end;
procedure TNotas.setNota(const Value: integer);
begin
  if IntToStr(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Nota';
  end
  else if (Value < 1) or (Value > 5) then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'O Intervalo da Nota  entre 1 a 5';
  end
  else
  begin
    FNotas := Value;
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
{ TAreaProjeto }
function TAreaProjeto.BuscarInstanciaNoBanco(const PSigla,
  PNome: string): boolean;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
  Result := False;
  with D_Modelo.QrConsultaAreaProjeto do
    begin
      Close;
      ParamByName('SIGLA_AREA').AsString := PSigla;
      ParamByName('DESCRICAO_AREA').AsString := PNome;
      Open;
      Result := (D_Modelo.QrConsultaAreaProjeto.RecordCount <> 0);
     if Result then
      begin
       FSigla   := D_Modelo.QrConsultaAreaProjeto.fieldByName('SIGLA_AREA').AsString;
       FNome    := D_Modelo.QrConsultaAreaProjeto.fieldByName('DESCRICAO_AREA').AsString;
       Alterou := False;
      end;
      end;
end;
function TAreaProjeto.CarregaDadosComboBox(var strRes: TCombobox;
  Query: string): Boolean;
var
  i: Integer;
begin
  for i := 0 to strRes.Items.Count-1 do
  strRes.Items.Clear;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          strRes.Items.Add(Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := (D_Modelo.QrExecuta.RecordCount = 0);
    Close;
  end;
end;
function TAreaProjeto.CarregaDadosStringGrid(var strRes: TStringGrid;
  Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);
 
end;
constructor TAreaProjeto.Create(const parmDataBaseName: string);
begin
  conexao := TConexao.create;
end;
destructor TAreaProjeto.Destroy;
begin
  if Alterou then
    Persistir(Sigla,Nome) ;
    conexao.Free;
    inherited Destroy;
end;
procedure TAreaProjeto.Executa(parm: array of String; Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;
function TAreaProjeto.LocalizaArea(const PNome: string): boolean;
begin
end;
function TAreaProjeto.NaoPersistir(const PSigla, PNome: string): boolean;
var
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  FSigla: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Frc := ProNormal;
  FMensagem := EmptyStr;
 // Result := BuscarInstanciaNoBanco(Sigla,Nome);
 //  if Result then
 //  begin
     SetLength(Parametros, 2);
     Query := 'DELETE FROM AREA_PROJETO WHERE DESCRICAO_AREA =:VAL01 AND SIGLA_AREA =:VAL02';
     IndPar := 0;
     CarregaParam(PNome);
     CarregaParam(PSigla);
     Executa(Parametros, Query);
//   end
//   else
//   begin
//     Frc := ProNaoEncontrouSigla;
//     FMensagem := 'A rea no existe';
//   end;

end;
function TAreaProjeto.Persistir(const PSigla, PNome: string): boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  FSigla: string;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  setSigla(Sigla);
  if not rc = proNormal then exit;
  setNome(Nome);
  if not rc = proNormal then exit;
  Result := BuscarInstanciaNoBanco(Sigla,Nome);
   if Result then
     begin
       Application.MessageBox('Erro: J existe Cadastrado.',
       'Ateno',MB_OK + MB_ICONWARNING);
       Exit;
  // SetLength(Parametros, 2);
   { Query := 'UPDATE AREA_PROJETO SET DESCRICAO_AREA = :VALOR01 '+
    'WHERE SIGLA_AREA = :VALOR02';
    IndPar := 0;
    CarregaParam(Nome);
    CarregaParam(Sigla);
    Executa(Parametros, Query);
    Alterou := false;
    Result := true;
  }
    end
    else
     begin
      SetLength(Parametros, 2);
      Query := 'INSERT INTO AREA_PROJETO (SIGLA_AREA, DESCRICAO_AREA)' +
      ' VALUES (:VAL01, :VAL02)' ;
      IndPar := 0;
      CarregaParam(Sigla);
      CarregaParam(Nome);
      Executa(Parametros, Query);
      Alterou := False;
      Result := True;
    end;
 
end;
procedure TAreaProjeto.setNome(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Descrio da rea';
  end
  else
  begin
    FNome := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
    Alterou := False;
  end;
end;
procedure TAreaProjeto.setSigla(const Value: string);
begin
end;
{ TVariavelEsforcoCustoConceitual }
function TVariavelEsforcoCustoConceitual.BuscaInstanciaVariavelEsforco(
  const PDescricaoECC, PGeraCodigo: string): Boolean;
begin
    with D_Modelo.QrConsultaECC_Projeto do
    begin
      Close;
      ParamByName('ECC').AsString := PDescricaoECC;
      ParamByName('GERA_CODIGO').AsString := PGeraCodigo;
      Open;
      Result := (D_Modelo.QrConsultaECC_Projeto.RecordCount<>0);
      FPeso :=  fieldByName('Peso').AsString;
      FSelecionado := fieldByName('Selecionado').AsString;
      FDescricaoECC := fieldByName('ECC').AsString;
    end;
end;
function TVariavelEsforcoCustoConceitual.CarregaDadosStringGrid(
  var strRes: TStringGrid; Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);
end;
constructor TVariavelEsforcoCustoConceitual.Create(
  const parmDataBaseName: string);
begin
  conexao := TConexao.create;
end;
destructor TVariavelEsforcoCustoConceitual.Destroy;
begin
    conexao.Free;
    inherited Destroy;
end;
procedure TVariavelEsforcoCustoConceitual.Executa(parm: array of String;
  Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;
 
function TVariavelEsforcoCustoConceitual.InserirVariavelEsforco(
  const PDescricaoECC, PGeraCodigo: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query, str: String;
  IndPar: Integer;
  i: integer;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  Query := 'SELECT COUNT(*) FROM ECC_PROJETO WHERE GERA_CODIGO = ' + QuotedStr(PGeraCodigo);
  str := RetornaDadosEmUmaVariavel(str,query);
   if  StrToIntDef(str, 0) > 9 then
     begin
       Application.MessageBox(Pchar(Format(EValorMaximoPermitido,[10])),'Informao',
       MB_OK+MB_ICONWARNING);
       exit;
     end;
  Result := BuscaInstanciaVariavelEsforco(PDescricaoECC,PGeraCodigo);
  if Result then
    begin
    SetLength(Parametros, 2);
    Query := 'DELETE FROM ECC_PROJETO WHERE ECC =:VALOR01 AND GERA_CODIGO =:VAL02';
    IndPar := 0;
    CarregaParam(PDescricaoECC);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Query := 'INSERT INTO ECC_PROJETO (ECC, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02)' ;
    IndPar := 0;
    CarregaParam(PDescricaoECC);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end
    else
    begin
    Query := 'INSERT INTO ECC_PROJETO (ECC, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02)' ;
    SetLength(Parametros, 2);
    IndPar := 0;
    CarregaParam(PDescricaoECC);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end;
end;
procedure TVariavelEsforcoCustoConceitual.MarcaApenasUmaVariavelDeCadaVez(
  const PDescricaoECC, PGeraCodigo: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
   //primeiro, tudo  alterado para falso, depois apenas uma nica
   //varivel  setada para true.. isto porque apenas uma pode ser
   //selecionada e escolhida para um determinado projeto.
  SetLength(Parametros, 2);
  Query := 'UPDATE ECC_PROJETO SET SELECIONADO = '''''#13#10 +
  'WHERE GERA_CODIGO = :VALOR01';
  IndPar := 0;
  CarregaParam(PGeraCodigo);
  Executa(Parametros, Query);
  SetLength(Parametros, 2);
  Query := 'UPDATE ECC_PROJETO SET SELECIONADO = ''X'''#13#10 +
  'WHERE GERA_CODIGO = :VALOR01'#13#10 +
  'AND ECC = :VALOR02';
  IndPar := 0;
  CarregaParam(PGeraCodigo);
  CarregaParam(PDescricaoECC);
  Executa(Parametros, Query);
end;
function TVariavelEsforcoCustoConceitual.NaoPersistir(const PDescricaoECC,
  PGeraCodigo: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
   Result := BuscaInstanciaVariavelEsforco(PDescricaoECC,PGeraCodigo);
   if Result then
     begin
       SetLength(Parametros, 3);
       Query := 'DELETE FROM ECC_PROJETO WHERE GERA_CODIGO =:VALOR01 AND ECC = :VALOR02';
       IndPar := 0;
       CarregaParam(PGeraCodigo);
       CarregaParam(DescricaoECC);
       Executa(Parametros, Query);
     end;
end;
procedure TVariavelEsforcoCustoConceitual.NaoPersistirVariavelDefault(
  const PDescricaoECC: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECC(PDescricaoECC);
  if not rc = proNormal then exit;
  SetLength(Parametros, 2);
  Query := 'DELETE FROM ECC WHERE DESCRICAO_ECC =:VALOR01';
  IndPar := 0;
  CarregaParam(DescricaoECC);
  Executa(Parametros, Query);

end;
function TVariavelEsforcoCustoConceitual.Persistir(const PDescricaoECC: string; const PGeraCodigo: string; const Peso: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECC(PDescricaoECC);
  if not rc = proNormal then exit;
  SetPeso(Peso);
  if not rc = proNormal then exit;
  Result := False;
   Result := BuscaInstanciaVariavelEsforco(PDescricaoECC,PGeraCodigo);
   if Result then
     begin
     SetLength(Parametros, 3);
    Query := 'DELETE FROM ECC_PROJETO WHERE GERA_CODIGO =:VALOR01 AND ECC = :VALOR02';
     IndPar := 0;
    CarregaParam(PGeraCodigo);
    CarregaParam(DescricaoECC);
    Executa(Parametros, Query);
    SetLength(Parametros, 3);
    Query := 'INSERT INTO ECC_PROJETO (ECC, PESO, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02, :VAL03)' ;
    IndPar := 0;
    CarregaParam(PDescricaoECC);
    CarregaParam(Peso);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end
    else
    begin
      SetLength(Parametros, 3);
      Query := 'INSERT INTO ECC_PROJETO (ECC, PESO, GERA_CODIGO)' +
      ' VALUES (:VAL01, :VAL02, :VAL03)' ;
      IndPar := 0;
      CarregaParam(PDescricaoECC);
      CarregaParam(Peso);
      CarregaParam(PGeraCodigo);
      Executa(Parametros, Query);
      Result := True;
    end;

end;
procedure TVariavelEsforcoCustoConceitual.PersistirVariavelDefault(
  const PDescricaoECC: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECC(PDescricaoECC);
  if not rc = proNormal then exit;
  SetLength(Parametros, 2);
  Query := 'DELETE FROM ECC WHERE DESCRICAO_ECC =:VALOR01';
  IndPar := 0;
  CarregaParam(DescricaoECC);
  Executa(Parametros, Query);
  SetLength(Parametros, 2);
  Query := 'INSERT INTO ECC (DESCRICAO_ECC)' +
  ' VALUES (:VAL01)' ;
  IndPar := 0;
  CarregaParam(PDescricaoECC);
  Executa(Parametros, Query);
end;
function TVariavelEsforcoCustoConceitual.RetornaDadosEmUmaVariavel(
  var Str: string; Query: string): string;
var
  i: Integer;
begin
  Str := EmptyStr;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          Str := (Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := Str;
    Close;
  end;
end;
procedure TVariavelEsforcoCustoConceitual.RetornaInstanciaBanco(
  const PDescricaoECC, PGeraCodigo: string);
begin
    with D_Modelo.QrConsultaECC_Projeto do
    begin
      Close;
      ParamByName('ECC').AsString := PDescricaoECC;
      ParamByName('GERA_CODIGO').AsString := PGeraCodigo;
      Open;

      FPeso :=  fieldByName('Peso').AsString;
      FSelecionado := fieldByName('Selecionado').AsString;
      FDescricaoECC := fieldByName('ECC').AsString;

    end;
end;
procedure TVariavelEsforcoCustoConceitual.SetDescricaoECC(
  const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Descrio do Esforo/Custo Conceitual';
  end
  else
  begin
    FDescricaoECC := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
procedure TVariavelEsforcoCustoConceitual.SetPeso(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Peso';
  end
  else
  begin
    FPeso := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
procedure TVariavelEsforcoCustoConceitual.SetSelecionado(
  const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor marcar o campo Selecionado';
  end
  else
  begin
    FSelecionado := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
{ TVariavelEsforcoCustoFinanceiro }
function TVariavelEsforcoCustoFinanceiro.BuscaInstanciaVariavelEsforco(
  const PDescricaoECF, PGeraCodigo: string): Boolean;
begin
    with D_Modelo.QrConsultaECF_Projeto do
    begin
      Close;
      ParamByName('ECF').AsString := PDescricaoECF;
      ParamByName('GERA_CODIGO').AsString := PGeraCodigo;
      Open;
      Result := (D_Modelo.QrConsultaECF_Projeto.RecordCount<>0);
      FPeso :=  fieldByName('Peso').AsString;
      FSelecionado := fieldByName('Selecionado').AsString;
      FDescricaoECF := fieldByName('ECF').AsString;
      end;
end;
function TVariavelEsforcoCustoFinanceiro.CarregaDadosStringGrid(
  var strRes: TStringGrid; Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);
end;
constructor TVariavelEsforcoCustoFinanceiro.Create(
  const parmDataBaseName: string);
begin
  conexao := TConexao.create;
end;
destructor TVariavelEsforcoCustoFinanceiro.Destroy;
begin
  conexao.Free;
  inherited Destroy;
end;
procedure TVariavelEsforcoCustoFinanceiro.Executa(parm: array of String;
  Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;
function TVariavelEsforcoCustoFinanceiro.InserirVariavelEsforco(
  const PDescricaoECF, PGeraCodigo: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query, str: String;
  IndPar: Integer;
  i: integer;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  Query := 'SELECT COUNT(*) FROM ECF_PROJETO WHERE GERA_CODIGO = ' + QuotedStr(PGeraCodigo);
  str := RetornaDadosEmUmaVariavel(str,query);
   if  StrToIntDef(str, 0) > 9 then
     begin
       Application.MessageBox(Pchar(Format(EValorMaximoPermitido,[10])),'Informao',
       MB_OK+MB_ICONWARNING);
       exit;
     end;

  Result := BuscaInstanciaVariavelEsforco(PDescricaoECF,PGeraCodigo);
  if Result then
    begin
    SetLength(Parametros, 2);
    Query := 'DELETE FROM ECF_PROJETO WHERE ECF =:VALOR01 AND GERA_CODIGO =:VAL02';
    IndPar := 0;
    CarregaParam(PDescricaoECF);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Query := 'INSERT INTO ECF_PROJETO (ECF, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02)' ;
    IndPar := 0;
    CarregaParam(PDescricaoECF);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end
    else
    begin
    Query := 'INSERT INTO ECF_PROJETO (ECF, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02)' ;
    SetLength(Parametros, 2);
    IndPar := 0;
    CarregaParam(PDescricaoECF);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end;
end;
procedure TVariavelEsforcoCustoFinanceiro.MarcaApenasUmaVariavelDeCadaVez(
  const PDescricaoECF, PGeraCodigo: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
   //primeiro, tudo  alterado para falso, depois apenas uma nica
   //varivel  setada para true.. isto porque apenas uma pode ser
   //selecionada e escolhida para um determinado projeto.
  SetLength(Parametros, 2);
  Query := 'UPDATE ECF_PROJETO SET SELECIONADO = '''''#13#10 +
  'WHERE GERA_CODIGO = :VALOR01';
  IndPar := 0;
  CarregaParam(PGeraCodigo);
  Executa(Parametros, Query);
  SetLength(Parametros, 2);
  Query := 'UPDATE ECF_PROJETO SET SELECIONADO = ''X'''#13#10 +
  'WHERE GERA_CODIGO = :VALOR01'#13#10 +
  'AND ECF = :VALOR02';
  IndPar := 0;
  CarregaParam(PGeraCodigo);
  CarregaParam(PDescricaoECF);
  Executa(Parametros, Query);
end;
function TVariavelEsforcoCustoFinanceiro.NaoPersistir(const PDescricaoECF,
  PGeraCodigo: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
   Result := BuscaInstanciaVariavelEsforco(PDescricaoECF,PGeraCodigo);
   if Result then
     begin
       SetLength(Parametros, 3);
       Query := 'DELETE FROM ECF_PROJETO WHERE GERA_CODIGO =:VALOR01 AND ECF = :VALOR02';
       IndPar := 0;
       CarregaParam(PGeraCodigo);
       CarregaParam(DescricaoECF);
       Executa(Parametros, Query);
     end;
end;

procedure TVariavelEsforcoCustoFinanceiro.NaoPersistirVariavelDefault(
  const PDescricaoECF: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECF(PDescricaoECF);
  if not rc = proNormal then exit;
  SetLength(Parametros, 2);
  Query := 'DELETE FROM ECF WHERE DESCRICAO_ECF =:VALOR01';
  IndPar := 0;
  CarregaParam(DescricaoECF);
  Executa(Parametros, Query);
end;
function TVariavelEsforcoCustoFinanceiro.Persistir(const PDescricaoECF,
  PGeraCodigo, Peso: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECF(PDescricaoECF);
  if not rc = proNormal then exit;
  SetPeso(Peso);
  if not rc = proNormal then exit;
  Result := False;
   Result := BuscaInstanciaVariavelEsforco(PDescricaoECF,PGeraCodigo);
   if Result then
     begin
     SetLength(Parametros, 3);
    Query := 'DELETE FROM ECF_PROJETO WHERE GERA_CODIGO =:VALOR01 AND ECF = :VALOR02';
     IndPar := 0;
    CarregaParam(PGeraCodigo);
    CarregaParam(DescricaoECF);
    Executa(Parametros, Query);
    SetLength(Parametros, 3);
    Query := 'INSERT INTO ECF_PROJETO (ECF, PESO, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02, :VAL03)' ;
    IndPar := 0;
    CarregaParam(PDescricaoECF);
    CarregaParam(Peso);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end
    else
    begin
      SetLength(Parametros, 3);
      Query := 'INSERT INTO ECF_PROJETO (ECF, PESO, GERA_CODIGO)' +
      ' VALUES (:VAL01, :VAL02, :VAL03)' ;
      IndPar := 0;
      CarregaParam(PDescricaoECF);
      CarregaParam(Peso);
      CarregaParam(PGeraCodigo);
      Executa(Parametros, Query);
      Result := True;
    end;

end;
 
procedure TVariavelEsforcoCustoFinanceiro.PersistirVariavelDefault(
  const PDescricaoECF: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECF(PDescricaoECF);
  if not rc = proNormal then exit;
  SetLength(Parametros, 2);
  Query := 'DELETE FROM ECF WHERE DESCRICAO_ECF =:VALOR01';
  IndPar := 0;
  CarregaParam(DescricaoECF);
  Executa(Parametros, Query);
  SetLength(Parametros, 2);
  Query := 'INSERT INTO ECF (DESCRICAO_ECF)' +
  ' VALUES (:VAL01)' ;
  IndPar := 0;
  CarregaParam(PDescricaoECF);
  Executa(Parametros, Query);
end;
function TVariavelEsforcoCustoFinanceiro.RetornaDadosEmUmaVariavel(
  var Str: string; Query: string): string;
var
  i: Integer;
begin
  Str := EmptyStr;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          Str := (Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := Str;
    Close;
  end;

end;
procedure TVariavelEsforcoCustoFinanceiro.RetornaInstanciaBanco(
  const PDescricaoECF, PGeraCodigo: string);
begin
    with D_Modelo.QrConsultaECF_Projeto do
    begin
      Close;
      ParamByName('ECF').AsString := PDescricaoECF;
      ParamByName('GERA_CODIGO').AsString := PGeraCodigo;
      Open;

      FPeso :=  fieldByName('Peso').AsString;
      FSelecionado := fieldByName('Selecionado').AsString;
      FDescricaoECF := fieldByName('ECF').AsString;

    end;
end;
procedure TVariavelEsforcoCustoFinanceiro.SetDescricaoECF(
  const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Descrio do Esforo/Custo Financeiro';
  end
  else
  begin
    FDescricaoECF := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
procedure TVariavelEsforcoCustoFinanceiro.SetPeso(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Peso';
  end
  else
  begin
    FPeso := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
procedure TVariavelEsforcoCustoFinanceiro.SetSelecionado(
  const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor marcar o campo Selecionado';
  end
  else
  begin
    FSelecionado := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
{ TVariavelEsforcoComplexidade }
function TVariavelEsforcoComplexidade.BuscaInstanciaVariavelEsforco(
  const PDescricaoECA, PGeraCodigo: string): Boolean;
begin
    with D_Modelo.QrConsultaECA_Projeto do
    begin
      Close;
      ParamByName('ECA').AsString := PDescricaoECA;
      ParamByName('GERA_CODIGO').AsString := PGeraCodigo;
      Open;
      Result := (D_Modelo.QrConsultaECA_Projeto.RecordCount<>0);
      FPeso :=  fieldByName('Peso').AsString;
      FSelecionado := fieldByName('Selecionado').AsString;
      FDescricaoECA := fieldByName('ECA').AsString;
      end;
end;
function TVariavelEsforcoComplexidade.CarregaDadosStringGrid(
  var strRes: TStringGrid; Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);
 
end;
constructor TVariavelEsforcoComplexidade.Create(
  const parmDataBaseName: string);
begin
  conexao := TConexao.create;
end;
destructor TVariavelEsforcoComplexidade.Destroy;
begin
  conexao.Free;
  inherited Destroy;
end;
procedure TVariavelEsforcoComplexidade.Executa(parm: array of String;
  Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;
function TVariavelEsforcoComplexidade.InserirVariavelEsforco(
  const PDescricaoECA, PGeraCodigo: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query, str: String;
  IndPar: Integer;
  i: integer;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  Query := 'SELECT COUNT(*) FROM ECA_PROJETO WHERE GERA_CODIGO = ' + QuotedStr(PGeraCodigo);
  str := RetornaDadosEmUmaVariavel(str,query);
   if  StrToIntDef(str, 0) > 9 then
     begin
       Application.MessageBox(Pchar(Format(EValorMaximoPermitido,[10])),'Informao',
       MB_OK+MB_ICONWARNING);
       exit;
     end;
  Result := BuscaInstanciaVariavelEsforco(PDescricaoECA,PGeraCodigo);
  if Result then
    begin
    SetLength(Parametros, 2);
    Query := 'DELETE FROM ECA_PROJETO WHERE ECA =:VALOR01 AND GERA_CODIGO =:VAL02';
    IndPar := 0;
    CarregaParam(PDescricaoECA);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Query := 'INSERT INTO ECA_PROJETO (ECA, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02)' ;
    IndPar := 0;
    CarregaParam(PDescricaoECA);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end
    else
    begin
    Query := 'INSERT INTO ECA_PROJETO (ECA, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02)' ;
    SetLength(Parametros, 2);
    IndPar := 0;
    CarregaParam(PDescricaoECA);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end;
end;
procedure TVariavelEsforcoComplexidade.MarcaApenasUmaVariavelDeCadaVez(
  const PDescricaoECA, PGeraCodigo: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
   //primeiro, tudo  alterado para falso, depois apenas uma nica
   //varivel  setada para true.. isto porque apenas uma pode ser
   //selecionada e escolhida para um determinado projeto.
  SetLength(Parametros, 2);
  Query := 'UPDATE ECA_PROJETO SET SELECIONADO = '''''#13#10 +
  'WHERE GERA_CODIGO = :VALOR01';
  IndPar := 0;
  CarregaParam(PGeraCodigo);
  Executa(Parametros, Query);
  SetLength(Parametros, 2);
  Query := 'UPDATE ECA_PROJETO SET SELECIONADO = ''X'''#13#10 +
  'WHERE GERA_CODIGO = :VALOR01'#13#10 +
  'AND ECA = :VALOR02';
  IndPar := 0;
  CarregaParam(PGeraCodigo);
  CarregaParam(PDescricaoECA);
  Executa(Parametros, Query);
end;
function TVariavelEsforcoComplexidade.NaoPersistir(const PDescricaoECA,
  PGeraCodigo: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
   Result := BuscaInstanciaVariavelEsforco(PDescricaoECA,PGeraCodigo);
   if Result then
     begin
       SetLength(Parametros, 3);
       Query := 'DELETE FROM ECA_PROJETO WHERE GERA_CODIGO =:VALOR01 AND ECA = :VALOR02';
       IndPar := 0;
       CarregaParam(PGeraCodigo);
       CarregaParam(DescricaoECA);
       Executa(Parametros, Query);
     end;

end;
procedure TVariavelEsforcoComplexidade.NaoPersistirVariavelDefault(
  const PDescricaoECA: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECA(PDescricaoECA);
  if not rc = proNormal then exit;
  SetLength(Parametros, 2);
  Query := 'DELETE FROM ECA WHERE ECA =:VALOR01';
  IndPar := 0;
  CarregaParam(DescricaoECA);
  Executa(Parametros, Query);
end;
function TVariavelEsforcoComplexidade.Persistir(const PDescricaoECA,
  PGeraCodigo, Peso: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECA(PDescricaoECA);
  if not rc = proNormal then exit;
  SetPeso(Peso);
  if not rc = proNormal then exit;
  Result := False;
   Result := BuscaInstanciaVariavelEsforco(PDescricaoECA,PGeraCodigo);
   if Result then
     begin
     SetLength(Parametros, 3);
    Query := 'DELETE FROM ECA_PROJETO WHERE GERA_CODIGO =:VALOR01 AND ECA = :VALOR02';
     IndPar := 0;
    CarregaParam(PGeraCodigo);
    CarregaParam(DescricaoECA);
    Executa(Parametros, Query);
    SetLength(Parametros, 3);
    Query := 'INSERT INTO ECA_PROJETO (ECA, PESO, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02, :VAL03)' ;
    IndPar := 0;
    CarregaParam(PDescricaoECA);
    CarregaParam(Peso);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end
    else
    begin
      SetLength(Parametros, 3);
      Query := 'INSERT INTO ECA_PROJETO (ECA, PESO, GERA_CODIGO)' +
      ' VALUES (:VAL01, :VAL02, :VAL03)' ;
      IndPar := 0;
      CarregaParam(PDescricaoECA);
      CarregaParam(Peso);
      CarregaParam(PGeraCodigo);
      Executa(Parametros, Query);
      Result := True;
    end;
 
end;
procedure TVariavelEsforcoComplexidade.PersistirVariavelDefault(
  const PDescricaoECA: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECA(PDescricaoECA);
  if not rc = proNormal then exit;
  SetLength(Parametros, 2);
  Query := 'DELETE FROM ECA WHERE ECA =:VALOR01';
  IndPar := 0;
  CarregaParam(DescricaoECA);
  Executa(Parametros, Query);
  SetLength(Parametros, 2);
  Query := 'INSERT INTO ECA (ECA)' +
  ' VALUES (:VAL01)' ;
  IndPar := 0;
  CarregaParam(PDescricaoECA);
  Executa(Parametros, Query);
end;
function TVariavelEsforcoComplexidade.RetornaDadosEmUmaVariavel(
  var Str: string; Query: string): string;
var
  i: Integer;
begin
  Str := EmptyStr;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          Str := (Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := Str;
    Close;
  end;

end;
procedure TVariavelEsforcoComplexidade.RetornaInstanciaBanco(
  const PDescricaoECA, PGeraCodigo: string);
begin
    with D_Modelo.QrConsultaECA_Projeto do
    begin
      Close;
      ParamByName('ECA').AsString := PDescricaoECA;
      ParamByName('GERA_CODIGO').AsString := PGeraCodigo;
      Open;

      FPeso :=  fieldByName('Peso').AsString;
      FSelecionado := fieldByName('Selecionado').AsString;
      FDescricaoECA := fieldByName('ECA').AsString;

    end;
end;
procedure TVariavelEsforcoComplexidade.SetDescricaoECA(
  const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Descrio do Esforo da Complexidade';
  end
  else
  begin
    FDescricaoECA := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
procedure TVariavelEsforcoComplexidade.SetPeso(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Peso';
  end
  else
  begin
    FPeso := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
procedure TVariavelEsforcoComplexidade.SetSelecionado(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor marcar o campo Selecionado';
  end
  else
  begin
    FSelecionado := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
{ TVariavelEsforcoTempo }
function TVariavelEsforcoTempo.BuscaInstanciaVariavelEsforco(
  const PDescricaoECT, PGeraCodigo: string): Boolean;
begin
    with D_Modelo.QrConsultaECT_Projeto do
    begin
      Close;
      ParamByName('ECT').AsString := PDescricaoECT;
      ParamByName('GERA_CODIGO').AsString := PGeraCodigo;
      Open;
      Result := (D_Modelo.QrConsultaECT_Projeto.RecordCount<>0);
      
      FPeso :=  fieldByName('Peso').AsString;
      FSelecionado := fieldByName('Selecionado').AsString;
      FDescricaoECT := fieldByName('ECT').AsString;
      end;
end;
function TVariavelEsforcoTempo.CarregaDadosStringGrid(
  var strRes: TStringGrid; Query: string): Boolean;
var
  iCorreLin, iCorreCol: Integer;
begin
  for iCorreCol := 0 to strRes.ColCount-1 do
    strRes.Cells[iCorreCol, 1] := '';
  strRes.RowCount := 2;
  iCorreLin := 1;
  // ***
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
   //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for iCorreCol := 0 to FieldCount-1 do
          strRes.Cells[iCorreCol, iCorreLin] := Fields[iCorreCol].AsString;
        inc(iCorreLin);
        Next;
      until EOF;
      strRes.RowCount := iCorreLin;
    end;
    Close;
  end;
  Result := (iCorreLin = 1);

end;
constructor TVariavelEsforcoTempo.Create(const parmDataBaseName: string);
begin
  conexao := TConexao.create;
end;
destructor TVariavelEsforcoTempo.Destroy;
begin
conexao.Free;
  inherited Destroy;
end;
procedure TVariavelEsforcoTempo.Executa(parm: array of String;
  Query: String);
var
  i : Integer;
  begin
    with D_Modelo.QrExecuta do
    begin
      SQL.Clear;
      SQL.Add(query);
      for i := 0 to (Params.Count -1) do
        params[i].AsString := parm[i];
        ExecSQL;
    end;
end;
function TVariavelEsforcoTempo.InserirVariavelEsforco(
  const PDescricaoECT, PGeraCodigo: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query, str: String;
  IndPar: Integer;
  i: integer;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
  Query := 'SELECT COUNT(*) FROM ECT_PROJETO WHERE GERA_CODIGO = ' + QuotedStr(PGeraCodigo);
  str := RetornaDadosEmUmaVariavel(str,query);
   if  StrToIntDef(str, 0) > 9 then
     begin
       Application.MessageBox(Pchar(Format(EValorMaximoPermitido,[10])),'Informao',
       MB_OK+MB_ICONWARNING);
       exit;
     end;
  Result := BuscaInstanciaVariavelEsforco(PDescricaoECT,PGeraCodigo);
  if Result then
    begin
    SetLength(Parametros, 2);
    Query := 'DELETE FROM ECT_PROJETO WHERE ECT =:VALOR01 AND GERA_CODIGO =:VAL02';
    IndPar := 0;
    CarregaParam(PDescricaoECT);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Query := 'INSERT INTO ECT_PROJETO (ECT, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02)' ;
    IndPar := 0;
    CarregaParam(PDescricaoECT);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end
    else
    begin
    Query := 'INSERT INTO ECT_PROJETO (ECT, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02)' ;
    SetLength(Parametros, 2);
    IndPar := 0;
    CarregaParam(PDescricaoECT);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end;
end;
procedure TVariavelEsforcoTempo.MarcaApenasUmaVariavelDeCadaVez(
  const PDescricaoECT, PGeraCodigo: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
   //primeiro, tudo  alterado para falso, depois apenas uma nica
   //varivel  setada para true.. isto porque apenas uma pode ser
   //selecionada e escolhida para um determinado projeto.
  SetLength(Parametros, 2);
  Query := 'UPDATE ECT_PROJETO SET SELECIONADO = '''''#13#10 +
  'WHERE GERA_CODIGO = :VALOR01';
  IndPar := 0;
  CarregaParam(PGeraCodigo);
  Executa(Parametros, Query);
  SetLength(Parametros, 2);
  Query := 'UPDATE ECT_PROJETO SET SELECIONADO = ''X'''#13#10 +
  'WHERE GERA_CODIGO = :VALOR01'#13#10 +
  'AND ECT = :VALOR02';
  IndPar := 0;
  CarregaParam(PGeraCodigo);
  CarregaParam(PDescricaoECT);
  Executa(Parametros, Query);

end;
function TVariavelEsforcoTempo.NaoPersistir(const PDescricaoECT,
  PGeraCodigo: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  Result := False;
   Result := BuscaInstanciaVariavelEsforco(PDescricaoECT,PGeraCodigo);
   if Result then
     begin
       SetLength(Parametros, 3);
       Query := 'DELETE FROM ECT_PROJETO WHERE GERA_CODIGO =:VALOR01 AND ECT = :VALOR02';
       IndPar := 0;
       CarregaParam(PGeraCodigo);
       CarregaParam(DescricaoECT);
       Executa(Parametros, Query);
     end;
 
end;
procedure TVariavelEsforcoTempo.NaoPersistirVariavelDefault(
  const PDescricaoECT: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECT(PDescricaoECT);
  if not rc = proNormal then exit;
  SetLength(Parametros, 2);
  Query := 'DELETE FROM ECT WHERE ECT =:VALOR01';
  IndPar := 0;
  CarregaParam(DescricaoECT);
  Executa(Parametros, Query);
end;
function TVariavelEsforcoTempo.Persistir(const PDescricaoECT, PGeraCodigo,
  Peso: string): Boolean;
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECT(PDescricaoECT);
  if not rc = proNormal then exit;
  SetPeso(Peso);
  if not rc = proNormal then exit;
  Result := False;
   Result := BuscaInstanciaVariavelEsforco(PDescricaoECT,PGeraCodigo);
   if Result then
     begin
     SetLength(Parametros, 3);
    Query := 'DELETE FROM ECT_PROJETO WHERE GERA_CODIGO =:VALOR01 AND ECT = :VALOR02';
     IndPar := 0;
    CarregaParam(PGeraCodigo);
    CarregaParam(DescricaoECT);
    Executa(Parametros, Query);
    SetLength(Parametros, 3);
    Query := 'INSERT INTO ECT_PROJETO (ECT, PESO, GERA_CODIGO)' +
    ' VALUES (:VAL01, :VAL02, :VAL03)' ;
    IndPar := 0;
    CarregaParam(PDescricaoECT);
    CarregaParam(Peso);
    CarregaParam(PGeraCodigo);
    Executa(Parametros, Query);
    Result := true;
    end
    else
    begin
      SetLength(Parametros, 3);
      Query := 'INSERT INTO ECT_PROJETO (ECT, PESO, GERA_CODIGO)' +
      ' VALUES (:VAL01, :VAL02, :VAL03)' ;
      IndPar := 0;
      CarregaParam(PDescricaoECT);
      CarregaParam(Peso);
      CarregaParam(PGeraCodigo);
      Executa(Parametros, Query);
      Result := True;
    end;
 

end;
procedure TVariavelEsforcoTempo.PersistirVariavelDefault(
  const PDescricaoECT: string);
var
  //Projeto: TProjeto;
  Parametros: array of String;
  Query: String;
  IndPar: Integer;
  str: string;
  procedure CarregaParam(valor: String);
  begin
    Parametros[IndPar] := valor;
    Inc(IndPar);
  end;
begin
  SetDescricaoECT(PDescricaoECT);
  if not rc = proNormal then exit;
  SetLength(Parametros, 2);
  Query := 'DELETE FROM ECT WHERE ECT =:VALOR01';
  IndPar := 0;
  CarregaParam(DescricaoECT);
  Executa(Parametros, Query);
  SetLength(Parametros, 2);
  Query := 'INSERT INTO ECT (ECT)' +
  ' VALUES (:VAL01)' ;
  IndPar := 0;
  CarregaParam(PDescricaoECT);
  Executa(Parametros, Query);

end;
function TVariavelEsforcoTempo.RetornaDadosEmUmaVariavel(var Str: string;
  Query: string): string;
var
  i: Integer;
begin
  Str := EmptyStr;
  with D_Modelo.QrExecuta do begin
    SQL.Clear;
    SQL.Add(Query);
  //apenas pra rodar consulta. no  para executar comandos INSERT, DELETE, UPDATE, etc
    Open;
    if not EOF then begin
      repeat
        for i := 0 to FieldCount-1 do
          Str := (Fields[i].AsString);
          Next;
      until EOF;
    end;
    Result := Str;
    Close;
  end;
 
end;
procedure TVariavelEsforcoTempo.RetornaInstanciaBanco(const PDescricaoECT,
  PGeraCodigo: string);
begin
    with D_Modelo.QrConsultaECT_Projeto do
    begin
      Close;
      ParamByName('ECT').AsString := PDescricaoECT;
      ParamByName('GERA_CODIGO').AsString := PGeraCodigo;
      Open;

      FPeso :=  fieldByName('Peso').AsString;
      FSelecionado := fieldByName('Selecionado').AsString;
      FDescricaoECT := fieldByName('ECT').AsString;

    end;
end;
procedure TVariavelEsforcoTempo.SetDescricaoECT(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Descrio do Esforo do Tempo';
  end
  else
  begin
    FDescricaoECT := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
procedure TVariavelEsforcoTempo.SetPeso(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor preencher o campo Peso';
  end
  else
  begin
    FPeso := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
procedure TVariavelEsforcoTempo.SetSelecionado(const Value: string);
begin
  if Trim(Value) = EmptyStr then
  begin
    Frc := ProErroConsistencia;
    FMensagem := 'Favor marcar o campo Selecionado';
  end
  else
  begin
    FSelecionado := Trim(Value);
    Frc := ProNormal;
    FMensagem := EmptyStr;
  end;
end;
end.

