﻿namespace WFATransaction;

interface

uses
  System.Drawing,
  System.Collections,
  System.Collections.Generic,
  System.Windows.Forms,
  System.ComponentModel,
  System.Data,
  System.Data.SqlClient;

type
  /// <summary>
  /// Summary description for MainForm.
  /// </summary>
  MainForm = partial class(System.Windows.Forms.Form)
  private
     var FConnection:SqlConnection;
     var FTransaction:SqlTransaction;
     var FCommand:SqlCommand;
     var FDataAdapter:SqlDataAdapter;
     var FDataSet:DataSet;
      method MainForm_Load(sender: System.Object; e: System.EventArgs);
      method toolStripButton1_Click(sender: System.Object; e: System.EventArgs);      
      method toolStripButton2_Click(sender: System.Object; e: System.EventArgs);
  protected
    method Dispose(disposing: Boolean); override;
  public
    constructor;

  end;

implementation

{$REGION Construction and Disposition}
constructor MainForm;
begin
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent();

  //
  // TODO: Add any constructor code after InitializeComponent call
  //
end;

method MainForm.Dispose(disposing: Boolean);
begin
  if disposing then begin
    if assigned(components) then
      components.Dispose();

    //
    // TODO: Add custom disposition code here
    //
  end;
  inherited Dispose(disposing);
end;
{$ENDREGION}

method MainForm.MainForm_Load(sender: System.Object; e: System.EventArgs);
begin
  {$region Criar a Conexão}  
  FConnection:=new  SqlConnection();
  FConnection.ConnectionString := 
  "Data Source=Technologies\sql2008; Initial Catalog=AdventureWorks;"+
  "Integrated Security=false; User Id=sa; password=997220201";
  FConnection.Open();
  if (FConnection.State <> ConnectionState.Open) then
  begin
    MessageBox.Show("Não foi possível conectar com o banco de dados!",
                    "Atenção",
                     MessageBoxButtons.OK,
                     MessageBoxIcon.Error
                   );
    exit;          
  end;
  {$endregion}
end;

method MainForm.toolStripButton1_Click(sender: System.Object; e: System.EventArgs);
begin
  {$region Executar a Instrução SQL}
  FDataSet:= new DataSet(); 
  FCommand:=new SqlCommand();
  FCommand.Connection:=FConnection;
  FCommand.CommandType:=CommandType.Text;
  FCommand.CommandText:="SELECT [ProductID]
                               ,[Name] 
                               ,[ProductNumber]
                               ,[Color]
                               ,[StandardCost]
                               ,[ListPrice] 
                          FROM  [Production].[Product]
                          WHERE Color is not null and StandardCost >0 ";
  
  
  FDataAdapter:=new SqlDataAdapter();
  FDataAdapter.SelectCommand:=FCommand;
  FDataAdapter.Fill(FDataSet,"Produto");
  {$endregion}  

  {$region Mostrar os dados para o usuário}
  dataGridView1.DataSource:=FDataSet;
  dataGridView1.DataMember:=FDataSet.Tables[0].TableName;
  {$endregion}

end;



method MainForm.toolStripButton2_Click(sender: System.Object; e: System.EventArgs);
begin
    {$region Abrir a transação}     
    FTransaction:=FConnection.BeginTransaction(IsolationLevel.ReadCommitted);
    {$endregion}

     
    try  
      {$region Executar atualização}
      var xcount:Integer;
      for xcount:=0 to FDataSet.Tables[0].Rows.Count -1 do 
      begin
        var xsql:= "Update [Production].[Product] set  [ListPrice] = [ListPrice]  -([ListPrice] *0.10) " +
                   " Where [ProductID]= "+ FDataSet.Tables[0].Rows[xcount]["ProductID"].ToString(); 
    
        FCommand.Transaction:=FTransaction;
        FCommand.CommandText:=xsql;
        FCommand.ExecuteNonQuery();

        {$region Simulação de um erro}
        if xcount=5 then
          begin
            //Convert.ToInt32("Core Database");
          end;
        {$endregion}
      end;
      {$endregion}
      
      {$region Efetivar} 
      FTransaction.Commit;
      MessageBox.Show("Operação realizada com sucesso!" ,
                      "Atenção",
                      MessageBoxButtons.OK,
                      MessageBoxIcon.Information);
      {$endregion}
    except on ex:Exception do
       begin 
         {$region Cancelar}
         FTransaction.Rollback();
         MessageBox.Show("Não foi possível aplicar o desconto, abaixo segue o erro:"  +#13 + ex.Message,
                         "Atenção",
                         MessageBoxButtons.OK,
                         MessageBoxIcon.Error
                        );
         {$endregion}
       end;
    end;
  end;


end.
